/*
 *
 * Copyright @ 1984 - 2000  Josef Heinen
 *
 * Permission to use, copy, and distribute this software and its
 * documentation for any purpose with or without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear
 * in supporting documentation.
 *
 * Permission to modify the software is granted, but not the right to
 * distribute the modified code.  Modifications are to be distributed
 * as patches to released version.
 *
 * This software is provided "as is" without express or implied warranty.
 *
 * Send your comments or suggestions to
 *  J.Heinen@kfa-juelich.de.
 *
 */

#ifdef _WIN32
#include <windows.h>
#endif

#if defined(_WIN32) && !defined(__GNUC__)
#define STDCALL __stdcall
#else
#ifdef STDCALL
#undef STDCALL
#endif
#define STDCALL
#endif

#include "gksdefs.h"

#define nint(a) ((int)(a + 0.5))

static
int pattern[120][33] = 
{
  {  4,   0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4, 255, 255, 187, 255,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4, 238, 255, 187, 255,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4, 187, 238, 187, 255,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4, 119, 221, 119, 221,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4, 119, 170, 119, 221,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4,  85, 170,  85, 187,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4,  85, 170,  85, 170,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4, 136,  85, 136,  34,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4, 136,  34, 136,  34,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4,   0,  68,   0,  17,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  4,   0,  34,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 128,   0,   8,   0, 128,   0,   8,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  34, 136,  34, 136,  34, 136,  34, 136,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 170,  85, 170,  85, 170,  85, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 170,   0, 170,   0, 170,   0, 170,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85,  85,  85,  85,  85,  85,  85,  85,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  17,  34,  68, 136,  17,  34,  68, 136,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 119, 119, 119, 119, 119, 119, 119,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  78, 207, 252, 228,  39,  63, 243, 114,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 127, 239, 253, 223, 254, 247, 191, 251,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 119, 119, 119,   0, 119, 119, 119,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 127, 127, 127,   0, 247, 247, 247,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 127, 255, 255, 255, 255, 255, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 127, 191, 223, 255, 253, 251, 247, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 125, 187, 198, 187, 125, 254, 254, 254,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   7, 139, 221, 184, 112, 232, 221, 142,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 170,  95, 191, 191, 170, 245, 251, 251,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 223, 175, 119, 119, 119, 119, 250, 253,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  64, 255,  64,  64,  79,  79,  79,  79,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 127, 255, 247, 255, 127, 255, 247, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 255, 221, 255, 119, 255, 221, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 221, 119, 221, 119, 221, 119, 221,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 255,  85, 255,  85, 255,  85, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 255,   0, 255,   0, 255,   0, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 238, 221, 187, 119, 238, 221, 187, 119,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 255, 255, 255,   0, 255, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 254, 253, 251, 247, 239, 223, 191, 127,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 255, 127, 255, 119, 255, 127, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 127, 127, 127, 127, 127, 127, 127,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 247, 227, 221,  62, 127, 254, 253, 251,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 235, 221, 190, 119, 255,  85, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 191,  95, 255, 255, 251, 245, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 252, 123, 183, 207, 243, 253, 254, 254,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 127, 127, 190, 193, 247, 247, 235,  28,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 239, 223, 171,  85,   0, 253, 251, 247,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 136, 118, 112, 112, 136, 103,   7,   7,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 255, 247, 235, 213, 170, 213, 235, 247,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 255, 247, 235, 213, 170, 213, 235, 247,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 127, 255, 255, 255, 255, 255, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 127, 255, 255, 255, 247, 255, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 255, 255, 255, 247, 255, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 255, 255, 255, 119, 255, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 255, 223, 255, 119, 255, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 255, 223, 255, 119, 255, 253, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 255, 221, 255, 119, 255, 253, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 255, 221, 255, 119, 255, 221, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  87, 255, 221, 255, 119, 255, 221, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  87, 255, 221, 255, 117, 255, 221, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 255, 221, 255, 117, 255, 221, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 255, 221, 255,  85, 255, 221, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 255,  93, 255,  85, 255, 221, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 255,  93, 255,  85, 255, 213, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 255,  85, 255,  85, 255, 213, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 255,  85, 255,  85, 255,  85, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 191,  85, 255,  85, 255,  85, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 191,  85, 255,  85, 251,  85, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 187,  85, 255,  85, 251,  85, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 187,  85, 255,  85, 187,  85, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 187,  85, 239,  85, 187,  85, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 187,  85, 239,  85, 187,  85, 254,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 187,  85, 238,  85, 187,  85, 254,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 187,  85, 238,  85, 187,  85, 238,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 171,  85, 238,  85, 187,  85, 238,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 171,  85, 238,  85, 186,  85, 238,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 170,  85, 238,  85, 186,  85, 238,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 170,  85, 238,  85, 170,  85, 238,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 170,  85, 174,  85, 170,  85, 238,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 170,  85, 174,  85, 170,  85, 234,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 170,  85, 170,  85, 170,  85, 234,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  85, 170,  85, 170,  85, 170,  85, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  21, 170,  85, 170,  85, 170,  85, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  21, 170,  85, 170,  81, 170,  85, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  17, 170,  85, 170,  81, 170,  85, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  17, 170,  85, 170,  17, 170,  85, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  17, 170,  69, 170,  17, 170,  85, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  17, 170,  69, 170,  17, 170,  84, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  17, 170,  68, 170,  17, 170,  84, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,  17, 170,  68, 170,  17, 170,  68, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   1, 170,  68, 170,  17, 170,  68, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   1, 170,  68, 170,  16, 170,  68, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 170,  68, 170,  16, 170,  68, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 170,  68, 170,   0, 170,  68, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 170,   4, 170,   0, 170,  68, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 170,   4, 170,   0, 170,  64, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 170,   0, 170,   0, 170,  64, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 170,   0, 170,   0, 170,   0, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,  42,   0, 170,   0, 170,   0, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,  42,   0, 170,   0, 162,   0, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,  34,   0, 170,   0, 162,   0, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,  34,   0, 170,   0,  34,   0, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,  34,   0, 138,   0,  34,   0, 170,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,  34,   0, 138,   0,  34,   0, 168,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,  34,   0, 136,   0,  34,   0, 168,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,  34,   0, 136,   0,  34,   0, 136,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,   2,   0, 136,   0,  34,   0, 136,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,   2,   0, 136,   0,  32,   0, 136,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0,   0,   0, 136,   0,  32,   0, 136,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 119, 119, 119, 119, 119, 119, 119,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 255, 255, 255,   0, 255, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 119, 187, 221, 238, 119, 187, 221, 238,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 238, 221, 187, 119, 238, 221, 187, 119,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8,   0, 119, 119, 119,   0, 119, 119, 119,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 126, 189, 219, 231, 231, 219, 189, 126,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 247, 247, 247, 247, 247, 247, 247, 247,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 255, 255, 255, 255,   0, 255, 255, 255,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 127, 191, 223, 239, 247, 251, 253, 254,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 254, 253, 251, 247, 239, 223, 191, 127,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 },
  {  8, 247, 247, 247, 247,   0, 247, 247, 247,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0,
          0,   0,   0,   0,   0,   0,   0,   0 }
};

static
float rgb[980][3] = 
{
  { 1.00000, 1.00000, 1.00000 },
  { 0.00000, 0.00000, 0.00000 },
  { 1.00000, 0.00000, 0.00000 },
  { 0.00000, 1.00000, 0.00000 },
  { 0.00000, 0.00000, 1.00000 },
  { 0.00000, 1.00000, 1.00000 },
  { 1.00000, 1.00000, 0.00000 },
  { 1.00000, 0.00000, 1.00000 },
  { 0.12500, 0.12500, 0.87500 },
  { 0.18750, 0.12500, 0.87500 },
  { 0.25000, 0.12500, 0.87500 },
  { 0.31250, 0.12500, 0.87500 },
  { 0.37500, 0.12500, 0.87500 },
  { 0.43750, 0.12500, 0.87500 },
  { 0.50000, 0.12500, 0.87500 },
  { 0.56250, 0.12500, 0.87500 },
  { 0.62500, 0.12500, 0.87500 },
  { 0.68750, 0.12500, 0.87500 },
  { 0.75000, 0.12500, 0.87500 },
  { 0.81250, 0.12500, 0.87500 },
  { 0.87500, 0.12500, 0.87500 },
  { 0.87500, 0.12500, 0.81250 },
  { 0.87500, 0.12500, 0.75000 },
  { 0.87500, 0.12500, 0.68750 },
  { 0.87500, 0.12500, 0.62500 },
  { 0.87500, 0.12500, 0.56250 },
  { 0.87500, 0.12500, 0.50000 },
  { 0.87500, 0.12500, 0.43750 },
  { 0.87500, 0.12500, 0.37500 },
  { 0.87500, 0.12500, 0.31250 },
  { 0.87500, 0.12500, 0.25000 },
  { 0.87500, 0.12500, 0.18750 },
  { 0.87500, 0.12500, 0.12500 },
  { 0.87500, 0.18750, 0.12500 },
  { 0.87500, 0.25000, 0.12500 },
  { 0.87500, 0.31250, 0.12500 },
  { 0.87500, 0.37500, 0.12500 },
  { 0.87500, 0.43750, 0.12500 },
  { 0.87500, 0.50000, 0.12500 },
  { 0.87500, 0.56250, 0.12500 },
  { 0.87500, 0.62500, 0.12500 },
  { 0.87500, 0.68750, 0.12500 },
  { 0.87500, 0.75000, 0.12500 },
  { 0.87500, 0.81250, 0.12500 },
  { 0.87500, 0.87500, 0.12500 },
  { 0.81250, 0.87500, 0.12500 },
  { 0.75000, 0.87500, 0.12500 },
  { 0.68750, 0.87500, 0.12500 },
  { 0.62500, 0.87500, 0.12500 },
  { 0.56250, 0.87500, 0.12500 },
  { 0.50000, 0.87500, 0.12500 },
  { 0.43750, 0.87500, 0.12500 },
  { 0.37500, 0.87500, 0.12500 },
  { 0.31250, 0.87500, 0.12500 },
  { 0.25000, 0.87500, 0.12500 },
  { 0.18750, 0.87500, 0.12500 },
  { 0.12500, 0.87500, 0.12500 },
  { 0.12500, 0.87500, 0.18750 },
  { 0.12500, 0.87500, 0.25000 },
  { 0.12500, 0.87500, 0.31250 },
  { 0.12500, 0.87500, 0.37500 },
  { 0.12500, 0.87500, 0.43750 },
  { 0.12500, 0.87500, 0.50000 },
  { 0.12500, 0.87500, 0.56250 },
  { 0.12500, 0.87500, 0.62500 },
  { 0.12500, 0.87500, 0.68750 },
  { 0.12500, 0.87500, 0.75000 },
  { 0.12500, 0.87500, 0.81250 },
  { 0.12500, 0.87500, 0.87500 },
  { 0.12500, 0.81250, 0.87500 },
  { 0.12500, 0.75000, 0.87500 },
  { 0.12500, 0.68750, 0.87500 },
  { 0.12500, 0.62500, 0.87500 },
  { 0.12500, 0.56250, 0.87500 },
  { 0.12500, 0.50000, 0.87500 },
  { 0.12500, 0.43750, 0.87500 },
  { 0.12500, 0.37500, 0.87500 },
  { 0.12500, 0.31250, 0.87500 },
  { 0.12500, 0.25000, 0.87500 },
  { 0.12500, 0.18750, 0.87500 },
  { 0.26667, 0.26667, 0.26667 },
  { 0.33333, 0.33333, 0.33333 },
  { 0.40000, 0.40000, 0.40000 },
  { 0.46667, 0.46667, 0.46667 },
  { 0.53333, 0.53333, 0.53333 },
  { 0.60000, 0.60000, 0.60000 },
  { 0.66667, 0.66667, 0.66667 },
  { 0.73333, 0.73333, 0.73333 },
  { 0.80000, 0.80000, 0.80000 },
  { 0.86667, 0.86667, 0.86667 },
  { 0.93333, 0.93333, 0.93333 },
  { 1.00000, 1.00000, 1.00000 },
  { 0.05000, 0.20000, 0.35000 },
  { 0.06667, 0.23333, 0.46667 },
  { 0.08333, 0.25000, 0.58333 },
  { 0.10000, 0.25000, 0.70000 },
  { 0.11667, 0.23333, 0.81667 },
  { 0.18333, 0.24167, 0.88333 },
  { 0.30000, 0.30000, 0.90000 },
  { 0.45833, 0.41667, 0.91667 },
  { 0.60000, 0.53333, 0.93333 },
  { 0.72500, 0.65000, 0.95000 },
  { 0.83333, 0.76667, 0.96667 },
  { 0.92500, 0.88333, 0.98333 },
  { 0.20000, 0.05000, 0.35000 },
  { 0.30000, 0.06667, 0.46667 },
  { 0.41667, 0.08333, 0.58333 },
  { 0.55000, 0.10000, 0.70000 },
  { 0.70000, 0.11667, 0.81667 },
  { 0.82500, 0.18333, 0.88333 },
  { 0.90000, 0.30000, 0.90000 },
  { 0.91667, 0.41667, 0.87500 },
  { 0.93333, 0.53333, 0.86667 },
  { 0.95000, 0.65000, 0.87500 },
  { 0.96667, 0.76667, 0.90000 },
  { 0.98333, 0.88333, 0.94167 },
  { 0.35000, 0.05000, 0.20000 },
  { 0.46667, 0.06667, 0.24000 },
  { 0.58333, 0.08333, 0.25000 },
  { 0.70000, 0.10000, 0.25000 },
  { 0.81667, 0.11667, 0.23333 },
  { 0.88333, 0.18333, 0.24167 },
  { 0.90000, 0.30000, 0.30000 },
  { 0.91667, 0.45833, 0.41667 },
  { 0.93333, 0.60000, 0.53333 },
  { 0.95000, 0.72500, 0.65000 },
  { 0.96667, 0.83333, 0.76667 },
  { 0.98333, 0.92500, 0.88333 },
  { 0.35000, 0.20000, 0.05000 },
  { 0.46667, 0.30000, 0.06667 },
  { 0.58333, 0.41667, 0.08333 },
  { 0.70000, 0.55000, 0.10000 },
  { 0.81667, 0.70000, 0.11667 },
  { 0.88333, 0.82500, 0.18333 },
  { 0.90000, 0.90000, 0.30000 },
  { 0.87500, 0.91667, 0.41667 },
  { 0.86667, 0.93333, 0.53333 },
  { 0.87500, 0.95000, 0.65000 },
  { 0.90000, 0.96667, 0.76667 },
  { 0.94167, 0.98333, 0.88333 },
  { 0.20000, 0.35000, 0.05000 },
  { 0.23333, 0.46667, 0.06667 },
  { 0.25833, 0.58333, 0.08333 },
  { 0.25000, 0.70000, 0.10000 },
  { 0.23333, 0.81667, 0.11667 },
  { 0.24167, 0.88333, 0.18333 },
  { 0.30000, 0.90000, 0.30000 },
  { 0.41667, 0.91667, 0.45833 },
  { 0.53333, 0.93333, 0.60000 },
  { 0.65000, 0.95000, 0.72500 },
  { 0.76667, 0.96667, 0.83333 },
  { 0.88333, 0.98333, 0.92500 },
  { 0.05000, 0.35000, 0.20000 },
  { 0.06667, 0.46667, 0.30000 },
  { 0.08333, 0.58333, 0.41667 },
  { 0.10000, 0.70000, 0.55000 },
  { 0.11667, 0.81667, 0.70000 },
  { 0.18333, 0.88333, 0.82500 },
  { 0.30000, 0.90000, 0.90000 },
  { 0.41667, 0.87500, 0.91667 },
  { 0.53333, 0.86667, 0.93333 },
  { 0.65000, 0.87500, 0.95000 },
  { 0.76667, 0.90000, 0.96667 },
  { 0.88333, 0.94167, 0.98333 },
  { 0.09800, 0.09800, 0.43920 },
  { 0.00000, 0.00000, 0.50200 },
  { 0.39220, 0.58430, 0.92940 },
  { 0.28240, 0.23920, 0.54510 },
  { 0.41570, 0.35290, 0.80390 },
  { 0.48240, 0.40780, 0.93330 },
  { 0.51760, 0.43920, 1.00000 },
  { 0.00000, 0.00000, 0.80390 },
  { 0.25490, 0.41180, 0.88240 },
  { 0.11760, 0.56470, 1.00000 },
  { 0.00000, 0.74900, 1.00000 },
  { 0.52940, 0.80780, 0.92160 },
  { 0.52940, 0.80780, 0.98040 },
  { 0.27450, 0.50980, 0.70590 },
  { 0.69020, 0.76860, 0.87060 },
  { 0.67840, 0.84710, 0.90200 },
  { 0.69020, 0.87840, 0.90200 },
  { 0.68630, 0.93330, 0.93330 },
  { 0.00000, 0.80780, 0.81960 },
  { 0.28240, 0.81960, 0.80000 },
  { 0.25100, 0.87840, 0.81570 },
  { 0.87840, 1.00000, 1.00000 },
  { 0.37250, 0.61960, 0.62750 },
  { 0.40000, 0.80390, 0.66670 },
  { 0.49800, 1.00000, 0.83140 },
  { 0.00000, 0.39220, 0.00000 },
  { 0.33330, 0.41960, 0.18430 },
  { 0.56080, 0.73730, 0.56080 },
  { 0.18040, 0.54510, 0.34120 },
  { 0.23530, 0.70200, 0.44310 },
  { 0.12550, 0.69800, 0.66670 },
  { 0.59610, 0.98430, 0.59610 },
  { 0.00000, 1.00000, 0.49800 },
  { 0.48630, 0.98820, 0.00000 },
  { 0.49800, 1.00000, 0.00000 },
  { 0.00000, 0.98040, 0.60390 },
  { 0.67840, 1.00000, 0.18430 },
  { 0.19610, 0.80390, 0.19610 },
  { 0.60390, 0.80390, 0.19610 },
  { 0.13330, 0.54510, 0.13330 },
  { 0.41960, 0.55690, 0.13730 },
  { 0.74120, 0.71760, 0.41960 },
  { 0.94120, 0.90200, 0.54900 },
  { 0.93330, 0.90980, 0.66670 },
  { 0.98040, 0.98040, 0.82350 },
  { 1.00000, 1.00000, 0.87840 },
  { 1.00000, 0.84310, 0.00000 },
  { 0.93330, 0.86670, 0.50980 },
  { 0.85490, 0.64710, 0.12550 },
  { 0.72160, 0.52550, 0.04310 },
  { 0.73730, 0.56080, 0.56080 },
  { 0.80390, 0.36080, 0.36080 },
  { 0.54510, 0.27060, 0.07450 },
  { 0.62750, 0.32160, 0.17650 },
  { 0.80390, 0.52160, 0.24710 },
  { 0.87060, 0.72160, 0.52940 },
  { 0.96080, 0.96080, 0.86270 },
  { 0.96080, 0.87060, 0.70200 },
  { 0.95690, 0.64310, 0.37650 },
  { 0.82350, 0.70590, 0.54900 },
  { 0.82350, 0.41180, 0.11760 },
  { 0.69800, 0.13330, 0.13330 },
  { 0.64710, 0.16470, 0.16470 },
  { 0.91370, 0.58820, 0.47840 },
  { 0.98040, 0.50200, 0.44710 },
  { 1.00000, 0.62750, 0.47840 },
  { 1.00000, 0.64710, 0.00000 },
  { 1.00000, 0.54900, 0.00000 },
  { 1.00000, 0.49800, 0.31370 },
  { 0.94120, 0.50200, 0.50200 },
  { 1.00000, 0.38820, 0.27840 },
  { 1.00000, 0.27060, 0.00000 },
  { 1.00000, 0.41180, 0.70590 },
  { 1.00000, 0.07840, 0.57650 },
  { 1.00000, 0.75290, 0.79610 },
  { 1.00000, 0.71370, 0.75690 },
  { 0.85880, 0.43920, 0.57650 },
  { 0.69020, 0.18820, 0.37650 },
  { 0.78040, 0.08240, 0.52160 },
  { 0.81570, 0.12550, 0.56470 },
  { 0.93330, 0.50980, 0.93330 },
  { 0.86670, 0.62750, 0.86670 },
  { 0.85490, 0.43920, 0.83920 },
  { 0.72940, 0.33330, 0.82750 },
  { 0.60000, 0.19610, 0.80000 },
  { 0.58040, 0.00000, 0.82750 },
  { 0.54120, 0.16860, 0.88630 },
  { 0.62750, 0.12550, 0.94120 },
  { 0.57650, 0.43920, 0.85880 },
  { 0.84710, 0.74900, 0.84710 },
  { 0.25000, 0.25000, 0.25000 },
  { 0.50000, 0.50000, 0.50000 },
  { 0.75000, 0.75000, 0.75000 },
  { 0.00000, 0.00000, 1.00000 },
  { 0.01818, 0.00000, 1.00000 },
  { 0.03636, 0.00000, 1.00000 },
  { 0.05455, 0.00000, 1.00000 },
  { 0.07273, 0.00000, 1.00000 },
  { 0.09091, 0.00000, 1.00000 },
  { 0.10909, 0.00000, 1.00000 },
  { 0.12727, 0.00000, 1.00000 },
  { 0.14545, 0.00000, 1.00000 },
  { 0.16364, 0.00000, 1.00000 },
  { 0.18182, 0.00000, 1.00000 },
  { 0.20000, 0.00000, 1.00000 },
  { 0.21818, 0.00000, 1.00000 },
  { 0.23636, 0.00000, 1.00000 },
  { 0.25455, 0.00000, 1.00000 },
  { 0.27273, 0.00000, 1.00000 },
  { 0.29091, 0.00000, 1.00000 },
  { 0.30909, 0.00000, 1.00000 },
  { 0.32727, 0.00000, 1.00000 },
  { 0.34545, 0.00000, 1.00000 },
  { 0.36364, 0.00000, 1.00000 },
  { 0.38182, 0.00000, 1.00000 },
  { 0.40000, 0.00000, 1.00000 },
  { 0.41818, 0.00000, 1.00000 },
  { 0.43636, 0.00000, 1.00000 },
  { 0.45455, 0.00000, 1.00000 },
  { 0.47273, 0.00000, 1.00000 },
  { 0.49091, 0.00000, 1.00000 },
  { 0.50909, 0.00000, 1.00000 },
  { 0.52727, 0.00000, 1.00000 },
  { 0.54545, 0.00000, 1.00000 },
  { 0.56364, 0.00000, 1.00000 },
  { 0.58182, 0.00000, 1.00000 },
  { 0.60000, 0.00000, 1.00000 },
  { 0.61818, 0.00000, 1.00000 },
  { 0.63636, 0.00000, 1.00000 },
  { 0.65454, 0.00000, 1.00000 },
  { 0.67273, 0.00000, 1.00000 },
  { 0.69091, 0.00000, 1.00000 },
  { 0.70909, 0.00000, 1.00000 },
  { 0.72727, 0.00000, 1.00000 },
  { 0.74545, 0.00000, 1.00000 },
  { 0.76364, 0.00000, 1.00000 },
  { 0.78182, 0.00000, 1.00000 },
  { 0.80000, 0.00000, 1.00000 },
  { 0.81818, 0.00000, 1.00000 },
  { 0.83636, 0.00000, 1.00000 },
  { 0.85454, 0.00000, 1.00000 },
  { 0.87273, 0.00000, 1.00000 },
  { 0.89091, 0.00000, 1.00000 },
  { 0.90909, 0.00000, 1.00000 },
  { 0.92727, 0.00000, 1.00000 },
  { 0.94545, 0.00000, 1.00000 },
  { 0.96364, 0.00000, 1.00000 },
  { 0.98182, 0.00000, 1.00000 },
  { 1.00000, 0.00000, 1.00000 },
  { 1.00000, 0.00000, 0.98182 },
  { 1.00000, 0.00000, 0.96364 },
  { 1.00000, 0.00000, 0.94545 },
  { 1.00000, 0.00000, 0.92727 },
  { 1.00000, 0.00000, 0.90909 },
  { 1.00000, 0.00000, 0.89091 },
  { 1.00000, 0.00000, 0.87273 },
  { 1.00000, 0.00000, 0.85455 },
  { 1.00000, 0.00000, 0.83636 },
  { 1.00000, 0.00000, 0.81818 },
  { 1.00000, 0.00000, 0.80000 },
  { 1.00000, 0.00000, 0.78182 },
  { 1.00000, 0.00000, 0.76364 },
  { 1.00000, 0.00000, 0.74545 },
  { 1.00000, 0.00000, 0.72727 },
  { 1.00000, 0.00000, 0.70909 },
  { 1.00000, 0.00000, 0.69091 },
  { 1.00000, 0.00000, 0.67273 },
  { 1.00000, 0.00000, 0.65455 },
  { 1.00000, 0.00000, 0.63636 },
  { 1.00000, 0.00000, 0.61818 },
  { 1.00000, 0.00000, 0.60000 },
  { 1.00000, 0.00000, 0.58182 },
  { 1.00000, 0.00000, 0.56364 },
  { 1.00000, 0.00000, 0.54545 },
  { 1.00000, 0.00000, 0.52727 },
  { 1.00000, 0.00000, 0.50909 },
  { 1.00000, 0.00000, 0.49091 },
  { 1.00000, 0.00000, 0.47273 },
  { 1.00000, 0.00000, 0.45455 },
  { 1.00000, 0.00000, 0.43636 },
  { 1.00000, 0.00000, 0.41818 },
  { 1.00000, 0.00000, 0.40000 },
  { 1.00000, 0.00000, 0.38182 },
  { 1.00000, 0.00000, 0.36364 },
  { 1.00000, 0.00000, 0.34546 },
  { 1.00000, 0.00000, 0.32727 },
  { 1.00000, 0.00000, 0.30909 },
  { 1.00000, 0.00000, 0.29091 },
  { 1.00000, 0.00000, 0.27273 },
  { 1.00000, 0.00000, 0.25455 },
  { 1.00000, 0.00000, 0.23636 },
  { 1.00000, 0.00000, 0.21818 },
  { 1.00000, 0.00000, 0.20000 },
  { 1.00000, 0.00000, 0.18182 },
  { 1.00000, 0.00000, 0.16364 },
  { 1.00000, 0.00000, 0.14546 },
  { 1.00000, 0.00000, 0.12727 },
  { 1.00000, 0.00000, 0.10909 },
  { 1.00000, 0.00000, 0.09091 },
  { 1.00000, 0.00000, 0.07273 },
  { 1.00000, 0.00000, 0.05455 },
  { 1.00000, 0.00000, 0.03636 },
  { 1.00000, 0.00000, 0.01818 },
  { 1.00000, 0.00000, 0.00000 },
  { 1.00000, 0.01818, 0.00000 },
  { 1.00000, 0.03636, 0.00000 },
  { 1.00000, 0.05455, 0.00000 },
  { 1.00000, 0.07273, 0.00000 },
  { 1.00000, 0.09091, 0.00000 },
  { 1.00000, 0.10909, 0.00000 },
  { 1.00000, 0.12727, 0.00000 },
  { 1.00000, 0.14545, 0.00000 },
  { 1.00000, 0.16364, 0.00000 },
  { 1.00000, 0.18182, 0.00000 },
  { 1.00000, 0.20000, 0.00000 },
  { 1.00000, 0.21818, 0.00000 },
  { 1.00000, 0.23636, 0.00000 },
  { 1.00000, 0.25455, 0.00000 },
  { 1.00000, 0.27273, 0.00000 },
  { 1.00000, 0.29091, 0.00000 },
  { 1.00000, 0.30909, 0.00000 },
  { 1.00000, 0.32727, 0.00000 },
  { 1.00000, 0.34545, 0.00000 },
  { 1.00000, 0.36364, 0.00000 },
  { 1.00000, 0.38182, 0.00000 },
  { 1.00000, 0.40000, 0.00000 },
  { 1.00000, 0.41818, 0.00000 },
  { 1.00000, 0.43636, 0.00000 },
  { 1.00000, 0.45455, 0.00000 },
  { 1.00000, 0.47273, 0.00000 },
  { 1.00000, 0.49091, 0.00000 },
  { 1.00000, 0.50909, 0.00000 },
  { 1.00000, 0.52727, 0.00000 },
  { 1.00000, 0.54545, 0.00000 },
  { 1.00000, 0.56364, 0.00000 },
  { 1.00000, 0.58182, 0.00000 },
  { 1.00000, 0.60000, 0.00000 },
  { 1.00000, 0.61818, 0.00000 },
  { 1.00000, 0.63636, 0.00000 },
  { 1.00000, 0.65454, 0.00000 },
  { 1.00000, 0.67273, 0.00000 },
  { 1.00000, 0.69091, 0.00000 },
  { 1.00000, 0.70909, 0.00000 },
  { 1.00000, 0.72727, 0.00000 },
  { 1.00000, 0.74545, 0.00000 },
  { 1.00000, 0.76364, 0.00000 },
  { 1.00000, 0.78182, 0.00000 },
  { 1.00000, 0.80000, 0.00000 },
  { 1.00000, 0.81818, 0.00000 },
  { 1.00000, 0.83636, 0.00000 },
  { 1.00000, 0.85454, 0.00000 },
  { 1.00000, 0.87273, 0.00000 },
  { 1.00000, 0.89091, 0.00000 },
  { 1.00000, 0.90909, 0.00000 },
  { 1.00000, 0.92727, 0.00000 },
  { 1.00000, 0.94545, 0.00000 },
  { 1.00000, 0.96364, 0.00000 },
  { 1.00000, 0.98182, 0.00000 },
  { 1.00000, 1.00000, 0.00000 },
  { 0.98182, 1.00000, 0.00000 },
  { 0.96364, 1.00000, 0.00000 },
  { 0.94545, 1.00000, 0.00000 },
  { 0.92727, 1.00000, 0.00000 },
  { 0.90909, 1.00000, 0.00000 },
  { 0.89091, 1.00000, 0.00000 },
  { 0.87273, 1.00000, 0.00000 },
  { 0.85455, 1.00000, 0.00000 },
  { 0.83636, 1.00000, 0.00000 },
  { 0.81818, 1.00000, 0.00000 },
  { 0.80000, 1.00000, 0.00000 },
  { 0.78182, 1.00000, 0.00000 },
  { 0.76364, 1.00000, 0.00000 },
  { 0.74545, 1.00000, 0.00000 },
  { 0.72727, 1.00000, 0.00000 },
  { 0.70909, 1.00000, 0.00000 },
  { 0.69091, 1.00000, 0.00000 },
  { 0.67273, 1.00000, 0.00000 },
  { 0.65455, 1.00000, 0.00000 },
  { 0.63636, 1.00000, 0.00000 },
  { 0.61818, 1.00000, 0.00000 },
  { 0.60000, 1.00000, 0.00000 },
  { 0.58182, 1.00000, 0.00000 },
  { 0.56364, 1.00000, 0.00000 },
  { 0.54545, 1.00000, 0.00000 },
  { 0.52727, 1.00000, 0.00000 },
  { 0.50909, 1.00000, 0.00000 },
  { 0.49091, 1.00000, 0.00000 },
  { 0.47273, 1.00000, 0.00000 },
  { 0.45455, 1.00000, 0.00000 },
  { 0.43636, 1.00000, 0.00000 },
  { 0.41818, 1.00000, 0.00000 },
  { 0.40000, 1.00000, 0.00000 },
  { 0.38182, 1.00000, 0.00000 },
  { 0.36364, 1.00000, 0.00000 },
  { 0.34546, 1.00000, 0.00000 },
  { 0.32727, 1.00000, 0.00000 },
  { 0.30909, 1.00000, 0.00000 },
  { 0.29091, 1.00000, 0.00000 },
  { 0.27273, 1.00000, 0.00000 },
  { 0.25455, 1.00000, 0.00000 },
  { 0.23636, 1.00000, 0.00000 },
  { 0.21818, 1.00000, 0.00000 },
  { 0.20000, 1.00000, 0.00000 },
  { 0.18182, 1.00000, 0.00000 },
  { 0.16364, 1.00000, 0.00000 },
  { 0.14546, 1.00000, 0.00000 },
  { 0.12727, 1.00000, 0.00000 },
  { 0.10909, 1.00000, 0.00000 },
  { 0.09091, 1.00000, 0.00000 },
  { 0.07273, 1.00000, 0.00000 },
  { 0.05455, 1.00000, 0.00000 },
  { 0.03636, 1.00000, 0.00000 },
  { 0.01818, 1.00000, 0.00000 },
  { 0.00000, 1.00000, 0.00000 },
  { 0.00000, 1.00000, 0.01818 },
  { 0.00000, 1.00000, 0.03636 },
  { 0.00000, 1.00000, 0.05455 },
  { 0.00000, 1.00000, 0.07273 },
  { 0.00000, 1.00000, 0.09091 },
  { 0.00000, 1.00000, 0.10909 },
  { 0.00000, 1.00000, 0.12727 },
  { 0.00000, 1.00000, 0.14545 },
  { 0.00000, 1.00000, 0.16364 },
  { 0.00000, 1.00000, 0.18182 },
  { 0.00000, 1.00000, 0.20000 },
  { 0.00000, 1.00000, 0.21818 },
  { 0.00000, 1.00000, 0.23636 },
  { 0.00000, 1.00000, 0.25455 },
  { 0.00000, 1.00000, 0.27273 },
  { 0.00000, 1.00000, 0.29091 },
  { 0.00000, 1.00000, 0.30909 },
  { 0.00000, 1.00000, 0.32727 },
  { 0.00000, 1.00000, 0.34545 },
  { 0.00000, 1.00000, 0.36364 },
  { 0.00000, 1.00000, 0.38182 },
  { 0.00000, 1.00000, 0.40000 },
  { 0.00000, 1.00000, 0.41818 },
  { 0.00000, 1.00000, 0.43636 },
  { 0.00000, 1.00000, 0.45455 },
  { 0.00000, 1.00000, 0.47273 },
  { 0.00000, 1.00000, 0.49091 },
  { 0.00000, 1.00000, 0.50909 },
  { 0.00000, 1.00000, 0.52727 },
  { 0.00000, 1.00000, 0.54545 },
  { 0.00000, 1.00000, 0.56364 },
  { 0.00000, 1.00000, 0.58182 },
  { 0.00000, 1.00000, 0.60000 },
  { 0.00000, 1.00000, 0.61818 },
  { 0.00000, 1.00000, 0.63636 },
  { 0.00000, 1.00000, 0.65454 },
  { 0.00000, 1.00000, 0.67273 },
  { 0.00000, 1.00000, 0.69091 },
  { 0.00000, 1.00000, 0.70909 },
  { 0.00000, 1.00000, 0.72727 },
  { 0.00000, 1.00000, 0.74545 },
  { 0.00000, 1.00000, 0.76364 },
  { 0.00000, 1.00000, 0.78182 },
  { 0.00000, 1.00000, 0.80000 },
  { 0.00000, 1.00000, 0.81818 },
  { 0.00000, 1.00000, 0.83636 },
  { 0.00000, 1.00000, 0.85454 },
  { 0.00000, 1.00000, 0.87273 },
  { 0.00000, 1.00000, 0.89091 },
  { 0.00000, 1.00000, 0.90909 },
  { 0.00000, 1.00000, 0.92727 },
  { 0.00000, 1.00000, 0.94545 },
  { 0.00000, 1.00000, 0.96364 },
  { 0.00000, 1.00000, 0.98182 },
  { 0.00000, 1.00000, 1.00000 },
  { 0.00000, 0.98182, 1.00000 },
  { 0.00000, 0.96364, 1.00000 },
  { 0.00000, 0.94545, 1.00000 },
  { 0.00000, 0.92727, 1.00000 },
  { 0.00000, 0.90909, 1.00000 },
  { 0.00000, 0.89091, 1.00000 },
  { 0.00000, 0.87273, 1.00000 },
  { 0.00000, 0.85455, 1.00000 },
  { 0.00000, 0.83636, 1.00000 },
  { 0.00000, 0.81818, 1.00000 },
  { 0.00000, 0.80000, 1.00000 },
  { 0.00000, 0.78182, 1.00000 },
  { 0.00000, 0.76364, 1.00000 },
  { 0.00000, 0.74545, 1.00000 },
  { 0.00000, 0.72727, 1.00000 },
  { 0.00000, 0.70909, 1.00000 },
  { 0.00000, 0.69091, 1.00000 },
  { 0.00000, 0.67273, 1.00000 },
  { 0.00000, 0.65455, 1.00000 },
  { 0.00000, 0.63636, 1.00000 },
  { 0.00000, 0.61818, 1.00000 },
  { 0.00000, 0.60000, 1.00000 },
  { 0.00000, 0.58182, 1.00000 },
  { 0.00000, 0.56364, 1.00000 },
  { 0.00000, 0.54545, 1.00000 },
  { 0.00000, 0.52727, 1.00000 },
  { 0.00000, 0.50909, 1.00000 },
  { 0.00000, 0.49091, 1.00000 },
  { 0.00000, 0.47273, 1.00000 },
  { 0.00000, 0.45455, 1.00000 },
  { 0.00000, 0.43636, 1.00000 },
  { 0.00000, 0.41818, 1.00000 },
  { 0.00000, 0.40000, 1.00000 },
  { 0.00000, 0.38182, 1.00000 },
  { 0.00000, 0.36364, 1.00000 },
  { 0.00000, 0.34546, 1.00000 },
  { 0.00000, 0.32727, 1.00000 },
  { 0.00000, 0.30909, 1.00000 },
  { 0.00000, 0.29091, 1.00000 },
  { 0.00000, 0.27273, 1.00000 },
  { 0.00000, 0.25455, 1.00000 },
  { 0.00000, 0.23636, 1.00000 },
  { 0.00000, 0.21818, 1.00000 },
  { 0.00000, 0.20000, 1.00000 },
  { 0.00000, 0.18182, 1.00000 },
  { 0.00000, 0.16364, 1.00000 },
  { 0.00000, 0.14546, 1.00000 },
  { 0.00000, 0.12727, 1.00000 },
  { 0.00000, 0.10909, 1.00000 },
  { 0.00000, 0.09091, 1.00000 },
  { 0.00000, 0.07273, 1.00000 },
  { 0.00000, 0.05455, 1.00000 },
  { 0.00000, 0.03636, 1.00000 },
  { 0.00000, 0.01818, 1.00000 },
  { 0.00000, 0.00000, 1.00000 },
  { 0.18000, 0.18000, 0.18000 },
  { 0.19491, 0.19491, 0.19491 },
  { 0.20982, 0.20982, 0.20982 },
  { 0.22473, 0.22473, 0.22473 },
  { 0.23964, 0.23964, 0.23964 },
  { 0.25455, 0.25455, 0.25455 },
  { 0.26945, 0.26945, 0.26945 },
  { 0.28436, 0.28436, 0.28436 },
  { 0.29927, 0.29927, 0.29927 },
  { 0.31418, 0.31418, 0.31418 },
  { 0.32909, 0.32909, 0.32909 },
  { 0.34400, 0.34400, 0.34400 },
  { 0.35891, 0.35891, 0.35891 },
  { 0.37382, 0.37382, 0.37382 },
  { 0.38873, 0.38873, 0.38873 },
  { 0.40364, 0.40364, 0.40364 },
  { 0.41855, 0.41855, 0.41855 },
  { 0.43345, 0.43345, 0.43345 },
  { 0.44836, 0.44836, 0.44836 },
  { 0.46327, 0.46327, 0.46327 },
  { 0.47818, 0.47818, 0.47818 },
  { 0.49309, 0.49309, 0.49309 },
  { 0.50800, 0.50800, 0.50800 },
  { 0.52291, 0.52291, 0.52291 },
  { 0.53782, 0.53782, 0.53782 },
  { 0.55273, 0.55273, 0.55273 },
  { 0.56764, 0.56764, 0.56764 },
  { 0.58255, 0.58255, 0.58255 },
  { 0.59745, 0.59745, 0.59745 },
  { 0.61236, 0.61236, 0.61236 },
  { 0.62727, 0.62727, 0.62727 },
  { 0.64218, 0.64218, 0.64218 },
  { 0.65709, 0.65709, 0.65709 },
  { 0.67200, 0.67200, 0.67200 },
  { 0.68691, 0.68691, 0.68691 },
  { 0.70182, 0.70182, 0.70182 },
  { 0.71673, 0.71673, 0.71673 },
  { 0.73164, 0.73164, 0.73164 },
  { 0.74655, 0.74655, 0.74655 },
  { 0.76145, 0.76145, 0.76145 },
  { 0.77636, 0.77636, 0.77636 },
  { 0.79127, 0.79127, 0.79127 },
  { 0.80618, 0.80618, 0.80618 },
  { 0.82109, 0.82109, 0.82109 },
  { 0.83600, 0.83600, 0.83600 },
  { 0.85091, 0.85091, 0.85091 },
  { 0.86582, 0.86582, 0.86582 },
  { 0.88073, 0.88073, 0.88073 },
  { 0.89564, 0.89564, 0.89564 },
  { 0.91055, 0.91055, 0.91055 },
  { 0.92545, 0.92545, 0.92545 },
  { 0.94036, 0.94036, 0.94036 },
  { 0.95527, 0.95527, 0.95527 },
  { 0.97018, 0.97018, 0.97018 },
  { 0.98509, 0.98509, 0.98509 },
  { 1.00000, 1.00000, 1.00000 },
  { 0.00000, 0.00000, 0.18000 },
  { 0.00000, 0.00000, 0.20733 },
  { 0.00000, 0.00000, 0.23467 },
  { 0.00000, 0.00000, 0.26200 },
  { 0.00000, 0.00000, 0.28933 },
  { 0.00000, 0.00000, 0.31667 },
  { 0.00000, 0.00000, 0.34400 },
  { 0.00000, 0.00000, 0.37133 },
  { 0.00000, 0.00000, 0.39867 },
  { 0.00000, 0.00000, 0.42600 },
  { 0.00000, 0.00000, 0.45333 },
  { 0.00000, 0.00000, 0.48067 },
  { 0.00000, 0.00000, 0.50800 },
  { 0.00000, 0.00000, 0.53533 },
  { 0.00000, 0.00000, 0.56267 },
  { 0.00000, 0.00000, 0.59000 },
  { 0.00000, 0.00000, 0.61733 },
  { 0.00000, 0.00000, 0.64467 },
  { 0.00000, 0.00000, 0.67200 },
  { 0.00000, 0.00000, 0.69933 },
  { 0.00000, 0.00000, 0.72667 },
  { 0.00000, 0.00000, 0.75400 },
  { 0.00000, 0.00000, 0.78133 },
  { 0.00000, 0.00000, 0.80867 },
  { 0.00000, 0.00000, 0.83600 },
  { 0.00000, 0.00000, 0.86333 },
  { 0.00000, 0.00000, 0.89067 },
  { 0.00000, 0.00000, 0.91800 },
  { 0.03333, 0.03333, 1.00000 },
  { 0.06667, 0.06667, 1.00000 },
  { 0.10000, 0.10000, 1.00000 },
  { 0.13333, 0.13333, 1.00000 },
  { 0.16667, 0.16667, 1.00000 },
  { 0.20000, 0.20000, 1.00000 },
  { 0.23333, 0.23333, 1.00000 },
  { 0.26667, 0.26667, 1.00000 },
  { 0.30000, 0.30000, 1.00000 },
  { 0.33333, 0.33333, 1.00000 },
  { 0.36667, 0.36667, 1.00000 },
  { 0.40000, 0.40000, 1.00000 },
  { 0.43333, 0.43333, 1.00000 },
  { 0.46667, 0.46667, 1.00000 },
  { 0.50000, 0.50000, 1.00000 },
  { 0.53333, 0.53333, 1.00000 },
  { 0.56667, 0.56667, 1.00000 },
  { 0.60000, 0.60000, 1.00000 },
  { 0.63333, 0.63333, 1.00000 },
  { 0.66667, 0.66667, 1.00000 },
  { 0.70000, 0.70000, 1.00000 },
  { 0.73333, 0.73333, 1.00000 },
  { 0.76667, 0.76667, 1.00000 },
  { 0.80000, 0.80000, 1.00000 },
  { 0.83333, 0.83333, 1.00000 },
  { 0.86667, 0.86667, 1.00000 },
  { 0.90000, 0.90000, 1.00000 },
  { 0.93333, 0.93333, 1.00000 },
  { 0.18000, 0.00000, 0.18000 },
  { 0.20733, 0.00000, 0.20733 },
  { 0.23467, 0.00000, 0.23467 },
  { 0.26200, 0.00000, 0.26200 },
  { 0.28933, 0.00000, 0.28933 },
  { 0.31667, 0.00000, 0.31667 },
  { 0.34400, 0.00000, 0.34400 },
  { 0.37133, 0.00000, 0.37133 },
  { 0.39867, 0.00000, 0.39867 },
  { 0.42600, 0.00000, 0.42600 },
  { 0.45333, 0.00000, 0.45333 },
  { 0.48067, 0.00000, 0.48067 },
  { 0.50800, 0.00000, 0.50800 },
  { 0.53533, 0.00000, 0.53533 },
  { 0.56267, 0.00000, 0.56267 },
  { 0.59000, 0.00000, 0.59000 },
  { 0.61733, 0.00000, 0.61733 },
  { 0.64467, 0.00000, 0.64467 },
  { 0.67200, 0.00000, 0.67200 },
  { 0.69933, 0.00000, 0.69933 },
  { 0.72667, 0.00000, 0.72667 },
  { 0.75400, 0.00000, 0.75400 },
  { 0.78133, 0.00000, 0.78133 },
  { 0.80867, 0.00000, 0.80867 },
  { 0.83600, 0.00000, 0.83600 },
  { 0.86333, 0.00000, 0.86333 },
  { 0.89067, 0.00000, 0.89067 },
  { 0.91800, 0.00000, 0.91800 },
  { 1.00000, 0.03333, 1.00000 },
  { 1.00000, 0.06667, 1.00000 },
  { 1.00000, 0.10000, 1.00000 },
  { 1.00000, 0.13333, 1.00000 },
  { 1.00000, 0.16667, 1.00000 },
  { 1.00000, 0.20000, 1.00000 },
  { 1.00000, 0.23333, 1.00000 },
  { 1.00000, 0.26667, 1.00000 },
  { 1.00000, 0.30000, 1.00000 },
  { 1.00000, 0.33333, 1.00000 },
  { 1.00000, 0.36667, 1.00000 },
  { 1.00000, 0.40000, 1.00000 },
  { 1.00000, 0.43333, 1.00000 },
  { 1.00000, 0.46667, 1.00000 },
  { 1.00000, 0.50000, 1.00000 },
  { 1.00000, 0.53333, 1.00000 },
  { 1.00000, 0.56667, 1.00000 },
  { 1.00000, 0.60000, 1.00000 },
  { 1.00000, 0.63333, 1.00000 },
  { 1.00000, 0.66667, 1.00000 },
  { 1.00000, 0.70000, 1.00000 },
  { 1.00000, 0.73333, 1.00000 },
  { 1.00000, 0.76667, 1.00000 },
  { 1.00000, 0.80000, 1.00000 },
  { 1.00000, 0.83333, 1.00000 },
  { 1.00000, 0.86667, 1.00000 },
  { 1.00000, 0.90000, 1.00000 },
  { 1.00000, 0.93333, 1.00000 },
  { 0.18000, 0.00000, 0.00000 },
  { 0.20733, 0.00000, 0.00000 },
  { 0.23467, 0.00000, 0.00000 },
  { 0.26200, 0.00000, 0.00000 },
  { 0.28933, 0.00000, 0.00000 },
  { 0.31667, 0.00000, 0.00000 },
  { 0.34400, 0.00000, 0.00000 },
  { 0.37133, 0.00000, 0.00000 },
  { 0.39867, 0.00000, 0.00000 },
  { 0.42600, 0.00000, 0.00000 },
  { 0.45333, 0.00000, 0.00000 },
  { 0.48067, 0.00000, 0.00000 },
  { 0.50800, 0.00000, 0.00000 },
  { 0.53533, 0.00000, 0.00000 },
  { 0.56267, 0.00000, 0.00000 },
  { 0.59000, 0.00000, 0.00000 },
  { 0.61733, 0.00000, 0.00000 },
  { 0.64467, 0.00000, 0.00000 },
  { 0.67200, 0.00000, 0.00000 },
  { 0.69933, 0.00000, 0.00000 },
  { 0.72667, 0.00000, 0.00000 },
  { 0.75400, 0.00000, 0.00000 },
  { 0.78133, 0.00000, 0.00000 },
  { 0.80867, 0.00000, 0.00000 },
  { 0.83600, 0.00000, 0.00000 },
  { 0.86333, 0.00000, 0.00000 },
  { 0.89067, 0.00000, 0.00000 },
  { 0.91800, 0.00000, 0.00000 },
  { 1.00000, 0.03333, 0.03333 },
  { 1.00000, 0.06667, 0.06667 },
  { 1.00000, 0.10000, 0.10000 },
  { 1.00000, 0.13333, 0.13333 },
  { 1.00000, 0.16667, 0.16667 },
  { 1.00000, 0.20000, 0.20000 },
  { 1.00000, 0.23333, 0.23333 },
  { 1.00000, 0.26667, 0.26667 },
  { 1.00000, 0.30000, 0.30000 },
  { 1.00000, 0.33333, 0.33333 },
  { 1.00000, 0.36667, 0.36667 },
  { 1.00000, 0.40000, 0.40000 },
  { 1.00000, 0.43333, 0.43333 },
  { 1.00000, 0.46667, 0.46667 },
  { 1.00000, 0.50000, 0.50000 },
  { 1.00000, 0.53333, 0.53333 },
  { 1.00000, 0.56667, 0.56667 },
  { 1.00000, 0.60000, 0.60000 },
  { 1.00000, 0.63333, 0.63333 },
  { 1.00000, 0.66667, 0.66667 },
  { 1.00000, 0.70000, 0.70000 },
  { 1.00000, 0.73333, 0.73333 },
  { 1.00000, 0.76667, 0.76667 },
  { 1.00000, 0.80000, 0.80000 },
  { 1.00000, 0.83333, 0.83333 },
  { 1.00000, 0.86667, 0.86667 },
  { 1.00000, 0.90000, 0.90000 },
  { 1.00000, 0.93333, 0.93333 },
  { 0.18000, 0.18000, 0.00000 },
  { 0.20733, 0.20733, 0.00000 },
  { 0.23467, 0.23467, 0.00000 },
  { 0.26200, 0.26200, 0.00000 },
  { 0.28933, 0.28933, 0.00000 },
  { 0.31667, 0.31667, 0.00000 },
  { 0.34400, 0.34400, 0.00000 },
  { 0.37133, 0.37133, 0.00000 },
  { 0.39867, 0.39867, 0.00000 },
  { 0.42600, 0.42600, 0.00000 },
  { 0.45333, 0.45333, 0.00000 },
  { 0.48067, 0.48067, 0.00000 },
  { 0.50800, 0.50800, 0.00000 },
  { 0.53533, 0.53533, 0.00000 },
  { 0.56267, 0.56267, 0.00000 },
  { 0.59000, 0.59000, 0.00000 },
  { 0.61733, 0.61733, 0.00000 },
  { 0.64467, 0.64467, 0.00000 },
  { 0.67200, 0.67200, 0.00000 },
  { 0.69933, 0.69933, 0.00000 },
  { 0.72667, 0.72667, 0.00000 },
  { 0.75400, 0.75400, 0.00000 },
  { 0.78133, 0.78133, 0.00000 },
  { 0.80867, 0.80867, 0.00000 },
  { 0.83600, 0.83600, 0.00000 },
  { 0.86333, 0.86333, 0.00000 },
  { 0.89067, 0.89067, 0.00000 },
  { 0.91800, 0.91800, 0.00000 },
  { 1.00000, 1.00000, 0.03333 },
  { 1.00000, 1.00000, 0.06667 },
  { 1.00000, 1.00000, 0.10000 },
  { 1.00000, 1.00000, 0.13333 },
  { 1.00000, 1.00000, 0.16667 },
  { 1.00000, 1.00000, 0.20000 },
  { 1.00000, 1.00000, 0.23333 },
  { 1.00000, 1.00000, 0.26667 },
  { 1.00000, 1.00000, 0.30000 },
  { 1.00000, 1.00000, 0.33333 },
  { 1.00000, 1.00000, 0.36667 },
  { 1.00000, 1.00000, 0.40000 },
  { 1.00000, 1.00000, 0.43333 },
  { 1.00000, 1.00000, 0.46667 },
  { 1.00000, 1.00000, 0.50000 },
  { 1.00000, 1.00000, 0.53333 },
  { 1.00000, 1.00000, 0.56667 },
  { 1.00000, 1.00000, 0.60000 },
  { 1.00000, 1.00000, 0.63333 },
  { 1.00000, 1.00000, 0.66667 },
  { 1.00000, 1.00000, 0.70000 },
  { 1.00000, 1.00000, 0.73333 },
  { 1.00000, 1.00000, 0.76667 },
  { 1.00000, 1.00000, 0.80000 },
  { 1.00000, 1.00000, 0.83333 },
  { 1.00000, 1.00000, 0.86667 },
  { 1.00000, 1.00000, 0.90000 },
  { 1.00000, 1.00000, 0.93333 },
  { 0.00000, 0.18000, 0.00000 },
  { 0.00000, 0.20733, 0.00000 },
  { 0.00000, 0.23467, 0.00000 },
  { 0.00000, 0.26200, 0.00000 },
  { 0.00000, 0.28933, 0.00000 },
  { 0.00000, 0.31667, 0.00000 },
  { 0.00000, 0.34400, 0.00000 },
  { 0.00000, 0.37133, 0.00000 },
  { 0.00000, 0.39867, 0.00000 },
  { 0.00000, 0.42600, 0.00000 },
  { 0.00000, 0.45333, 0.00000 },
  { 0.00000, 0.48067, 0.00000 },
  { 0.00000, 0.50800, 0.00000 },
  { 0.00000, 0.53533, 0.00000 },
  { 0.00000, 0.56267, 0.00000 },
  { 0.00000, 0.59000, 0.00000 },
  { 0.00000, 0.61733, 0.00000 },
  { 0.00000, 0.64467, 0.00000 },
  { 0.00000, 0.67200, 0.00000 },
  { 0.00000, 0.69933, 0.00000 },
  { 0.00000, 0.72667, 0.00000 },
  { 0.00000, 0.75400, 0.00000 },
  { 0.00000, 0.78133, 0.00000 },
  { 0.00000, 0.80867, 0.00000 },
  { 0.00000, 0.83600, 0.00000 },
  { 0.00000, 0.86333, 0.00000 },
  { 0.00000, 0.89067, 0.00000 },
  { 0.00000, 0.91800, 0.00000 },
  { 0.03333, 1.00000, 0.03333 },
  { 0.06667, 1.00000, 0.06667 },
  { 0.10000, 1.00000, 0.10000 },
  { 0.13333, 1.00000, 0.13333 },
  { 0.16667, 1.00000, 0.16667 },
  { 0.20000, 1.00000, 0.20000 },
  { 0.23333, 1.00000, 0.23333 },
  { 0.26667, 1.00000, 0.26667 },
  { 0.30000, 1.00000, 0.30000 },
  { 0.33333, 1.00000, 0.33333 },
  { 0.36667, 1.00000, 0.36667 },
  { 0.40000, 1.00000, 0.40000 },
  { 0.43333, 1.00000, 0.43333 },
  { 0.46667, 1.00000, 0.46667 },
  { 0.50000, 1.00000, 0.50000 },
  { 0.53333, 1.00000, 0.53333 },
  { 0.56667, 1.00000, 0.56667 },
  { 0.60000, 1.00000, 0.60000 },
  { 0.63333, 1.00000, 0.63333 },
  { 0.66667, 1.00000, 0.66667 },
  { 0.70000, 1.00000, 0.70000 },
  { 0.73333, 1.00000, 0.73333 },
  { 0.76667, 1.00000, 0.76667 },
  { 0.80000, 1.00000, 0.80000 },
  { 0.83333, 1.00000, 0.83333 },
  { 0.86667, 1.00000, 0.86667 },
  { 0.90000, 1.00000, 0.90000 },
  { 0.93333, 1.00000, 0.93333 },
  { 0.00000, 0.18000, 0.18000 },
  { 0.00000, 0.20733, 0.20733 },
  { 0.00000, 0.23467, 0.23467 },
  { 0.00000, 0.26200, 0.26200 },
  { 0.00000, 0.28933, 0.28933 },
  { 0.00000, 0.31667, 0.31667 },
  { 0.00000, 0.34400, 0.34400 },
  { 0.00000, 0.37133, 0.37133 },
  { 0.00000, 0.39867, 0.39867 },
  { 0.00000, 0.42600, 0.42600 },
  { 0.00000, 0.45333, 0.45333 },
  { 0.00000, 0.48067, 0.48067 },
  { 0.00000, 0.50800, 0.50800 },
  { 0.00000, 0.53533, 0.53533 },
  { 0.00000, 0.56267, 0.56267 },
  { 0.00000, 0.59000, 0.59000 },
  { 0.00000, 0.61733, 0.61733 },
  { 0.00000, 0.64467, 0.64467 },
  { 0.00000, 0.67200, 0.67200 },
  { 0.00000, 0.69933, 0.69933 },
  { 0.00000, 0.72667, 0.72667 },
  { 0.00000, 0.75400, 0.75400 },
  { 0.00000, 0.78133, 0.78133 },
  { 0.00000, 0.80867, 0.80867 },
  { 0.00000, 0.83600, 0.83600 },
  { 0.00000, 0.86333, 0.86333 },
  { 0.00000, 0.89067, 0.89067 },
  { 0.00000, 0.91800, 0.91800 },
  { 0.03333, 1.00000, 1.00000 },
  { 0.06667, 1.00000, 1.00000 },
  { 0.10000, 1.00000, 1.00000 },
  { 0.13333, 1.00000, 1.00000 },
  { 0.16667, 1.00000, 1.00000 },
  { 0.20000, 1.00000, 1.00000 },
  { 0.23333, 1.00000, 1.00000 },
  { 0.26667, 1.00000, 1.00000 },
  { 0.30000, 1.00000, 1.00000 },
  { 0.33333, 1.00000, 1.00000 },
  { 0.36667, 1.00000, 1.00000 },
  { 0.40000, 1.00000, 1.00000 },
  { 0.43333, 1.00000, 1.00000 },
  { 0.46667, 1.00000, 1.00000 },
  { 0.50000, 1.00000, 1.00000 },
  { 0.53333, 1.00000, 1.00000 },
  { 0.56667, 1.00000, 1.00000 },
  { 0.60000, 1.00000, 1.00000 },
  { 0.63333, 1.00000, 1.00000 },
  { 0.66667, 1.00000, 1.00000 },
  { 0.70000, 1.00000, 1.00000 },
  { 0.73333, 1.00000, 1.00000 },
  { 0.76667, 1.00000, 1.00000 },
  { 0.80000, 1.00000, 1.00000 },
  { 0.83333, 1.00000, 1.00000 },
  { 0.86667, 1.00000, 1.00000 },
  { 0.90000, 1.00000, 1.00000 },
  { 0.93333, 1.00000, 1.00000 }
};

static
int pix[256] = 
{
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};


int STDCALL GORD(int *set, int *length, int *element)
{
  int i;

  for (i = 0; i < *length; i++)
    if (set[i] == *element)
      return (i + 1);

  return (0);
}

int STDCALL GANY(int *set, int *length, int *element)
{
  int i;

  for (i = 0; i < *length; i++)
    if (set[i] == *element)
      return (1);

  return (0);

}

int STDCALL GALL(int *set, int *length, int *element)
{
  int i;

  for (i = 0; i < *length; i++)
    if (set[i] != *element)
      return (0);

  return (1);
}

void STDCALL GADD(int *element, int *set, int *length)
{
  int i;

  for (i = 0; i < *length; i++)
    if (set[i] == 0)
      {
	set[i] = *element;
	return;
      }
}

void STDCALL GDEL(int *element, int *set, int *length)
{
  int i, j, k;

  k = *length;
  for (i = 0; i < k; i++)
    {
      if (set[i] == *element)
	{
	  for (j = i; j < --k; j++)
	    set[j] = set[j + 1];

	  set[k] = 0;
	  return;
	}
    }
  return;
}

void STDCALL GINI(int *set, int *length)
{
  int i;

  for (i = 0; i < *length; i++)
    set[i] = 0;
}

void STDCALL GNUM(int *set, int *length, int *result)
{
  int i;

  *result = 0;
  for (i = 0; i < *length; i++)
    if (set[i] != 0)
      (*result)++;
}

void STDCALL GKQPA(int *index, int *pa)
{
  int i, j, k;

  j = *index;
  if (j > 119)
    j = 119;
  else if (j < 0)
    j = 0;

  k = pattern[j][0];
  for (i = 0; i <= k; i++)
    pa[i] = pattern[j][i];
}

void STDCALL GKSPA(int *index, int *pa)
{
  int i, j, k;

  j = *index;
  if (j >= 0 && j <= 119)
    {
      k = pa[0];
      if (k == 4 || k == 8 || k == 32)
	for (i = 0; i <= k; i++)
	  pattern[j][i] = pa[i];
    }
}

void STDCALL GQRGB(int *index, float *red, float *green, float *blue)
{
  if (*index >= 0 && *index < 980)
    {
      *red   = rgb[*index][0];
      *green = rgb[*index][1];
      *blue  = rgb[*index][2];
    }
}

void STDCALL GSRGB(int *index, float *red, float *green, float *blue)
{
  if (*index >= 0 && *index < 980)
    {
      rgb[*index][0] = *red;
      rgb[*index][1] = *green;
      rgb[*index][2] = *blue;
    }
}

void STDCALL GQPIX(int *index, int *pixel)
{
  int i;

  if (*index >= 588)
    i = 80 + (*index - 588) / 56 * 12 + nint((*index - 588) % 56 * 11.0 / 56.0);
  else if (*index >= 257) 
    i = 8 + nint((*index - 257) / 330.0 * (72 - 1));
  else
    i = *index;

  if (i < 256)
    *pixel = pix[i];
}

void STDCALL GSPIX(int *index, int *pixel)
{
  if (*index < 256)
    pix[*index] = *pixel;
}

void STDCALL GKFVP(float *vp, float *xmax, float *ymax)
{
  register int i;
  float w, h, ratio;

/* fit viewport into available device space */

  ratio = (vp[1] - vp[0]) / (vp[3] - vp[2]);
  for (i = 1; i <= 2; i++)
    {
      w = vp[1] - vp[0];
      if (w > *xmax)
	{
	  vp[0] = 0;
	  vp[1] = *xmax;
	  vp[3] = vp[2] + *xmax / ratio;
	}
      h = vp[3] - vp[2];
      if (h > *ymax)
	{
	  vp[1] = vp[0] + *ymax * ratio;
	  vp[2] = 0;
	  vp[3] = *ymax;
	}
    }
  if (vp[1] > *xmax)
    {
      vp[0] = *xmax - (vp[1] - vp[0]);
      vp[1] = *xmax;
    }
  if (vp[3] > *ymax)
    {
      vp[2] = *ymax - (vp[3] - vp[2]);
      vp[3] = *ymax;
    }
}
