C*
C* Copyright @ 1995   Josef Heinen
C*
C* Permission to use, copy, and distribute this software and its
C* documentation for any purpose with or without fee is hereby granted,
C* provided that the above copyright notice appear in all copies and
C* that both that copyright notice and this permission notice appear
C* in supporting documentation.
C*
C* Permission to modify the software is granted, but not the right to
C* distribute the modified code.  Modifications are to be distributed
C* as patches to released version.
C*
C* This software is provided "as is" without express or implied warranty.
C*
C* Send your comments or suggestions to
C*  J.Heinen@kfa-juelich.de.
C*
C*
C* FACILITY:
C*
C*      Graphical Kernel System (GKS)
C*
C* ABSTRACT:
C*
C*      This module contains the AFM (Adobe Font Metrics) routines.
C*
C* AUTHOR(S):
C*
C*      J. Heinen
C*
C* VERSION:
C*
C*      V1.0
C*
C*
      SUBROUTINE GKAFM(FONT, CH, BUFF)
C*
      INTEGER FONT, CH, BUFF(256)
C*
      INTEGER WIDTHS(256, 29), PSMAP(32), DESCEN(29), CAPS(29)
      INTEGER PSFONT, CODE

      DATA (WIDTHS(I,  1), I =   1,   4) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I =   5,   8) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I =   9,  12) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I =  13,  16) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I =  17,  20) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I =  21,  24) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I =  25,  28) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I =  29,  32) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I =  33,  36) /  250,  333,  408,  500 /
      DATA (WIDTHS(I,  1), I =  37,  40) /  500,  833,  778,  333 /
      DATA (WIDTHS(I,  1), I =  41,  44) /  333,  333,  500,  564 /
      DATA (WIDTHS(I,  1), I =  45,  48) /  250,  564,  250,  278 /
      DATA (WIDTHS(I,  1), I =  49,  52) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  1), I =  53,  56) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  1), I =  57,  60) /  500,  500,  278,  278 /
      DATA (WIDTHS(I,  1), I =  61,  64) /  564,  564,  564,  444 /
      DATA (WIDTHS(I,  1), I =  65,  68) /  921,  722,  667,  667 /
      DATA (WIDTHS(I,  1), I =  69,  72) /  722,  611,  556,  722 /
      DATA (WIDTHS(I,  1), I =  73,  76) /  722,  333,  389,  722 /
      DATA (WIDTHS(I,  1), I =  77,  80) /  611,  889,  722,  722 /
      DATA (WIDTHS(I,  1), I =  81,  84) /  556,  722,  667,  556 /
      DATA (WIDTHS(I,  1), I =  85,  88) /  611,  722,  722,  944 /
      DATA (WIDTHS(I,  1), I =  89,  92) /  722,  722,  611,  333 /
      DATA (WIDTHS(I,  1), I =  93,  96) /  278,  333,  469,  500 /
      DATA (WIDTHS(I,  1), I =  97, 100) /  333,  444,  500,  444 /
      DATA (WIDTHS(I,  1), I = 101, 104) /  500,  444,  333,  500 /
      DATA (WIDTHS(I,  1), I = 105, 108) /  500,  278,  278,  500 /
      DATA (WIDTHS(I,  1), I = 109, 112) /  278,  778,  500,  500 /
      DATA (WIDTHS(I,  1), I = 113, 116) /  500,  500,  333,  389 /
      DATA (WIDTHS(I,  1), I = 117, 120) /  278,  500,  500,  722 /
      DATA (WIDTHS(I,  1), I = 121, 124) /  500,  500,  444,  480 /
      DATA (WIDTHS(I,  1), I = 125, 128) /  200,  480,  541,  250 /
      DATA (WIDTHS(I,  1), I = 129, 132) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I = 133, 136) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I = 137, 140) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I = 141, 144) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I = 145, 148) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I = 149, 152) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I = 153, 156) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I = 157, 160) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  1), I = 161, 164) /  250,  333,  500,  500 /
      DATA (WIDTHS(I,  1), I = 165, 168) /  500,  500,  200,  500 /
      DATA (WIDTHS(I,  1), I = 169, 172) /  333,  760,  276,  500 /
      DATA (WIDTHS(I,  1), I = 173, 176) /  564,  333,  760,  333 /
      DATA (WIDTHS(I,  1), I = 177, 180) /  400,  564,  300,  300 /
      DATA (WIDTHS(I,  1), I = 181, 184) /  333,  500,  453,  250 /
      DATA (WIDTHS(I,  1), I = 185, 188) /  333,  300,  310,  500 /
      DATA (WIDTHS(I,  1), I = 189, 192) /  750,  750,  750,  444 /
      DATA (WIDTHS(I,  1), I = 193, 196) /  722,  722,  722,  722 /
      DATA (WIDTHS(I,  1), I = 197, 200) /  722,  722,  889,  667 /
      DATA (WIDTHS(I,  1), I = 201, 204) /  611,  611,  611,  611 /
      DATA (WIDTHS(I,  1), I = 205, 208) /  333,  333,  333,  333 /
      DATA (WIDTHS(I,  1), I = 209, 212) /  722,  722,  722,  722 /
      DATA (WIDTHS(I,  1), I = 213, 216) /  722,  722,  722,  564 /
      DATA (WIDTHS(I,  1), I = 217, 220) /  722,  722,  722,  722 /
      DATA (WIDTHS(I,  1), I = 221, 224) /  722,  722,  556,  500 /
      DATA (WIDTHS(I,  1), I = 225, 228) /  444,  444,  444,  444 /
      DATA (WIDTHS(I,  1), I = 229, 232) /  444,  444,  667,  444 /
      DATA (WIDTHS(I,  1), I = 233, 236) /  444,  444,  444,  444 /
      DATA (WIDTHS(I,  1), I = 237, 240) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  1), I = 241, 244) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  1), I = 245, 248) /  500,  500,  500,  564 /
      DATA (WIDTHS(I,  1), I = 249, 252) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  1), I = 253, 256) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  2), I =   1,   4) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I =   5,   8) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I =   9,  12) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I =  13,  16) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I =  17,  20) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I =  21,  24) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I =  25,  28) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I =  29,  32) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I =  33,  36) /  250,  333,  420,  500 /
      DATA (WIDTHS(I,  2), I =  37,  40) /  500,  833,  778,  333 /
      DATA (WIDTHS(I,  2), I =  41,  44) /  333,  333,  500,  675 /
      DATA (WIDTHS(I,  2), I =  45,  48) /  250,  675,  250,  278 /
      DATA (WIDTHS(I,  2), I =  49,  52) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  2), I =  53,  56) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  2), I =  57,  60) /  500,  500,  333,  333 /
      DATA (WIDTHS(I,  2), I =  61,  64) /  675,  675,  675,  500 /
      DATA (WIDTHS(I,  2), I =  65,  68) /  920,  611,  611,  667 /
      DATA (WIDTHS(I,  2), I =  69,  72) /  722,  611,  611,  722 /
      DATA (WIDTHS(I,  2), I =  73,  76) /  722,  333,  444,  667 /
      DATA (WIDTHS(I,  2), I =  77,  80) /  556,  833,  667,  722 /
      DATA (WIDTHS(I,  2), I =  81,  84) /  611,  722,  611,  500 /
      DATA (WIDTHS(I,  2), I =  85,  88) /  556,  722,  611,  833 /
      DATA (WIDTHS(I,  2), I =  89,  92) /  611,  556,  556,  389 /
      DATA (WIDTHS(I,  2), I =  93,  96) /  278,  389,  422,  500 /
      DATA (WIDTHS(I,  2), I =  97, 100) /  333,  500,  500,  444 /
      DATA (WIDTHS(I,  2), I = 101, 104) /  500,  444,  278,  500 /
      DATA (WIDTHS(I,  2), I = 105, 108) /  500,  278,  278,  444 /
      DATA (WIDTHS(I,  2), I = 109, 112) /  278,  722,  500,  500 /
      DATA (WIDTHS(I,  2), I = 113, 116) /  500,  500,  389,  389 /
      DATA (WIDTHS(I,  2), I = 117, 120) /  278,  500,  444,  667 /
      DATA (WIDTHS(I,  2), I = 121, 124) /  444,  444,  389,  400 /
      DATA (WIDTHS(I,  2), I = 125, 128) /  275,  400,  541,  250 /
      DATA (WIDTHS(I,  2), I = 129, 132) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I = 133, 136) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I = 137, 140) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I = 141, 144) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I = 145, 148) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I = 149, 152) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I = 153, 156) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I = 157, 160) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  2), I = 161, 164) /  250,  389,  500,  500 /
      DATA (WIDTHS(I,  2), I = 165, 168) /  500,  500,  275,  500 /
      DATA (WIDTHS(I,  2), I = 169, 172) /  333,  760,  276,  500 /
      DATA (WIDTHS(I,  2), I = 173, 176) /  675,  333,  760,  333 /
      DATA (WIDTHS(I,  2), I = 177, 180) /  400,  675,  300,  300 /
      DATA (WIDTHS(I,  2), I = 181, 184) /  333,  500,  523,  250 /
      DATA (WIDTHS(I,  2), I = 185, 188) /  333,  300,  310,  500 /
      DATA (WIDTHS(I,  2), I = 189, 192) /  750,  750,  750,  500 /
      DATA (WIDTHS(I,  2), I = 193, 196) /  611,  611,  611,  611 /
      DATA (WIDTHS(I,  2), I = 197, 200) /  611,  611,  889,  667 /
      DATA (WIDTHS(I,  2), I = 201, 204) /  611,  611,  611,  611 /
      DATA (WIDTHS(I,  2), I = 205, 208) /  333,  333,  333,  333 /
      DATA (WIDTHS(I,  2), I = 209, 212) /  722,  667,  722,  722 /
      DATA (WIDTHS(I,  2), I = 213, 216) /  722,  722,  722,  675 /
      DATA (WIDTHS(I,  2), I = 217, 220) /  722,  722,  722,  722 /
      DATA (WIDTHS(I,  2), I = 221, 224) /  722,  556,  611,  500 /
      DATA (WIDTHS(I,  2), I = 225, 228) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  2), I = 229, 232) /  500,  500,  667,  444 /
      DATA (WIDTHS(I,  2), I = 233, 236) /  444,  444,  444,  444 /
      DATA (WIDTHS(I,  2), I = 237, 240) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  2), I = 241, 244) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  2), I = 245, 248) /  500,  500,  500,  675 /
      DATA (WIDTHS(I,  2), I = 249, 252) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  2), I = 253, 256) /  500,  444,  500,  444 /
      DATA (WIDTHS(I,  3), I =   1,   4) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I =   5,   8) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I =   9,  12) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I =  13,  16) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I =  17,  20) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I =  21,  24) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I =  25,  28) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I =  29,  32) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I =  33,  36) /  250,  333,  555,  500 /
      DATA (WIDTHS(I,  3), I =  37,  40) /  500, 1000,  833,  333 /
      DATA (WIDTHS(I,  3), I =  41,  44) /  333,  333,  500,  570 /
      DATA (WIDTHS(I,  3), I =  45,  48) /  250,  570,  250,  278 /
      DATA (WIDTHS(I,  3), I =  49,  52) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  3), I =  53,  56) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  3), I =  57,  60) /  500,  500,  333,  333 /
      DATA (WIDTHS(I,  3), I =  61,  64) /  570,  570,  570,  500 /
      DATA (WIDTHS(I,  3), I =  65,  68) /  930,  722,  667,  722 /
      DATA (WIDTHS(I,  3), I =  69,  72) /  722,  667,  611,  778 /
      DATA (WIDTHS(I,  3), I =  73,  76) /  778,  389,  500,  778 /
      DATA (WIDTHS(I,  3), I =  77,  80) /  667,  944,  722,  778 /
      DATA (WIDTHS(I,  3), I =  81,  84) /  611,  778,  722,  556 /
      DATA (WIDTHS(I,  3), I =  85,  88) /  667,  722,  722, 1000 /
      DATA (WIDTHS(I,  3), I =  89,  92) /  722,  722,  667,  333 /
      DATA (WIDTHS(I,  3), I =  93,  96) /  278,  333,  581,  500 /
      DATA (WIDTHS(I,  3), I =  97, 100) /  333,  500,  556,  444 /
      DATA (WIDTHS(I,  3), I = 101, 104) /  556,  444,  333,  500 /
      DATA (WIDTHS(I,  3), I = 105, 108) /  556,  278,  333,  556 /
      DATA (WIDTHS(I,  3), I = 109, 112) /  278,  833,  556,  500 /
      DATA (WIDTHS(I,  3), I = 113, 116) /  556,  556,  444,  389 /
      DATA (WIDTHS(I,  3), I = 117, 120) /  333,  556,  500,  722 /
      DATA (WIDTHS(I,  3), I = 121, 124) /  500,  500,  444,  394 /
      DATA (WIDTHS(I,  3), I = 125, 128) /  220,  394,  520,  250 /
      DATA (WIDTHS(I,  3), I = 129, 132) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I = 133, 136) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I = 137, 140) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I = 141, 144) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I = 145, 148) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I = 149, 152) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I = 153, 156) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I = 157, 160) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  3), I = 161, 164) /  250,  333,  500,  500 /
      DATA (WIDTHS(I,  3), I = 165, 168) /  500,  500,  220,  500 /
      DATA (WIDTHS(I,  3), I = 169, 172) /  333,  747,  300,  500 /
      DATA (WIDTHS(I,  3), I = 173, 176) /  570,  333,  747,  333 /
      DATA (WIDTHS(I,  3), I = 177, 180) /  400,  570,  300,  300 /
      DATA (WIDTHS(I,  3), I = 181, 184) /  333,  556,  540,  250 /
      DATA (WIDTHS(I,  3), I = 185, 188) /  333,  300,  330,  500 /
      DATA (WIDTHS(I,  3), I = 189, 192) /  750,  750,  750,  500 /
      DATA (WIDTHS(I,  3), I = 193, 196) /  722,  722,  722,  722 /
      DATA (WIDTHS(I,  3), I = 197, 200) /  722,  722, 1000,  722 /
      DATA (WIDTHS(I,  3), I = 201, 204) /  667,  667,  667,  667 /
      DATA (WIDTHS(I,  3), I = 205, 208) /  389,  389,  389,  389 /
      DATA (WIDTHS(I,  3), I = 209, 212) /  722,  722,  778,  778 /
      DATA (WIDTHS(I,  3), I = 213, 216) /  778,  778,  778,  570 /
      DATA (WIDTHS(I,  3), I = 217, 220) /  778,  722,  722,  722 /
      DATA (WIDTHS(I,  3), I = 221, 224) /  722,  722,  611,  556 /
      DATA (WIDTHS(I,  3), I = 225, 228) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  3), I = 229, 232) /  500,  500,  722,  444 /
      DATA (WIDTHS(I,  3), I = 233, 236) /  444,  444,  444,  444 /
      DATA (WIDTHS(I,  3), I = 237, 240) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  3), I = 241, 244) /  500,  556,  500,  500 /
      DATA (WIDTHS(I,  3), I = 245, 248) /  500,  500,  500,  570 /
      DATA (WIDTHS(I,  3), I = 249, 252) /  500,  556,  556,  556 /
      DATA (WIDTHS(I,  3), I = 253, 256) /  556,  500,  556,  500 /
      DATA (WIDTHS(I,  4), I =   1,   4) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I =   5,   8) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I =   9,  12) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I =  13,  16) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I =  17,  20) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I =  21,  24) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I =  25,  28) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I =  29,  32) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I =  33,  36) /  250,  389,  555,  500 /
      DATA (WIDTHS(I,  4), I =  37,  40) /  500,  833,  778,  333 /
      DATA (WIDTHS(I,  4), I =  41,  44) /  333,  333,  500,  570 /
      DATA (WIDTHS(I,  4), I =  45,  48) /  250,  606,  250,  278 /
      DATA (WIDTHS(I,  4), I =  49,  52) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  4), I =  53,  56) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  4), I =  57,  60) /  500,  500,  333,  333 /
      DATA (WIDTHS(I,  4), I =  61,  64) /  570,  570,  570,  500 /
      DATA (WIDTHS(I,  4), I =  65,  68) /  832,  667,  667,  667 /
      DATA (WIDTHS(I,  4), I =  69,  72) /  722,  667,  667,  722 /
      DATA (WIDTHS(I,  4), I =  73,  76) /  778,  389,  500,  667 /
      DATA (WIDTHS(I,  4), I =  77,  80) /  611,  889,  722,  722 /
      DATA (WIDTHS(I,  4), I =  81,  84) /  611,  722,  667,  556 /
      DATA (WIDTHS(I,  4), I =  85,  88) /  611,  722,  667,  889 /
      DATA (WIDTHS(I,  4), I =  89,  92) /  667,  611,  611,  333 /
      DATA (WIDTHS(I,  4), I =  93,  96) /  278,  333,  570,  500 /
      DATA (WIDTHS(I,  4), I =  97, 100) /  333,  500,  500,  444 /
      DATA (WIDTHS(I,  4), I = 101, 104) /  500,  444,  333,  500 /
      DATA (WIDTHS(I,  4), I = 105, 108) /  556,  278,  278,  500 /
      DATA (WIDTHS(I,  4), I = 109, 112) /  278,  778,  556,  500 /
      DATA (WIDTHS(I,  4), I = 113, 116) /  500,  500,  389,  389 /
      DATA (WIDTHS(I,  4), I = 117, 120) /  278,  556,  444,  667 /
      DATA (WIDTHS(I,  4), I = 121, 124) /  500,  444,  389,  348 /
      DATA (WIDTHS(I,  4), I = 125, 128) /  220,  348,  570,  250 /
      DATA (WIDTHS(I,  4), I = 129, 132) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I = 133, 136) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I = 137, 140) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I = 141, 144) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I = 145, 148) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I = 149, 152) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I = 153, 156) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I = 157, 160) /  250,  250,  250,  250 /
      DATA (WIDTHS(I,  4), I = 161, 164) /  250,  389,  500,  500 /
      DATA (WIDTHS(I,  4), I = 165, 168) /  500,  500,  220,  500 /
      DATA (WIDTHS(I,  4), I = 169, 172) /  333,  747,  266,  500 /
      DATA (WIDTHS(I,  4), I = 173, 176) /  606,  333,  747,  333 /
      DATA (WIDTHS(I,  4), I = 177, 180) /  400,  570,  300,  300 /
      DATA (WIDTHS(I,  4), I = 181, 184) /  333,  576,  500,  250 /
      DATA (WIDTHS(I,  4), I = 185, 188) /  333,  300,  300,  500 /
      DATA (WIDTHS(I,  4), I = 189, 192) /  750,  750,  750,  500 /
      DATA (WIDTHS(I,  4), I = 193, 196) /  667,  667,  667,  667 /
      DATA (WIDTHS(I,  4), I = 197, 200) /  667,  667,  944,  667 /
      DATA (WIDTHS(I,  4), I = 201, 204) /  667,  667,  667,  667 /
      DATA (WIDTHS(I,  4), I = 205, 208) /  389,  389,  389,  389 /
      DATA (WIDTHS(I,  4), I = 209, 212) /  722,  722,  722,  722 /
      DATA (WIDTHS(I,  4), I = 213, 216) /  722,  722,  722,  570 /
      DATA (WIDTHS(I,  4), I = 217, 220) /  722,  722,  722,  722 /
      DATA (WIDTHS(I,  4), I = 221, 224) /  722,  611,  611,  500 /
      DATA (WIDTHS(I,  4), I = 225, 228) /  500,  500,  500,  500 /
      DATA (WIDTHS(I,  4), I = 229, 232) /  500,  500,  722,  444 /
      DATA (WIDTHS(I,  4), I = 233, 236) /  444,  444,  444,  444 /
      DATA (WIDTHS(I,  4), I = 237, 240) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  4), I = 241, 244) /  500,  556,  500,  500 /
      DATA (WIDTHS(I,  4), I = 245, 248) /  500,  500,  500,  570 /
      DATA (WIDTHS(I,  4), I = 249, 252) /  500,  556,  556,  556 /
      DATA (WIDTHS(I,  4), I = 253, 256) /  556,  444,  500,  444 /
      DATA (WIDTHS(I,  5), I =   1,   4) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I =   5,   8) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I =   9,  12) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I =  13,  16) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I =  17,  20) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I =  21,  24) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I =  25,  28) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I =  29,  32) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I =  33,  36) /  278,  278,  355,  556 /
      DATA (WIDTHS(I,  5), I =  37,  40) /  556,  889,  667,  222 /
      DATA (WIDTHS(I,  5), I =  41,  44) /  333,  333,  389,  584 /
      DATA (WIDTHS(I,  5), I =  45,  48) /  278,  584,  278,  278 /
      DATA (WIDTHS(I,  5), I =  49,  52) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  5), I =  53,  56) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  5), I =  57,  60) /  556,  556,  278,  278 /
      DATA (WIDTHS(I,  5), I =  61,  64) /  584,  584,  584,  556 /
      DATA (WIDTHS(I,  5), I =  65,  68) / 1015,  667,  667,  722 /
      DATA (WIDTHS(I,  5), I =  69,  72) /  722,  667,  611,  778 /
      DATA (WIDTHS(I,  5), I =  73,  76) /  722,  278,  500,  667 /
      DATA (WIDTHS(I,  5), I =  77,  80) /  556,  833,  722,  778 /
      DATA (WIDTHS(I,  5), I =  81,  84) /  667,  778,  722,  667 /
      DATA (WIDTHS(I,  5), I =  85,  88) /  611,  722,  667,  944 /
      DATA (WIDTHS(I,  5), I =  89,  92) /  667,  667,  611,  278 /
      DATA (WIDTHS(I,  5), I =  93,  96) /  278,  278,  469,  556 /
      DATA (WIDTHS(I,  5), I =  97, 100) /  222,  556,  556,  500 /
      DATA (WIDTHS(I,  5), I = 101, 104) /  556,  556,  278,  556 /
      DATA (WIDTHS(I,  5), I = 105, 108) /  556,  222,  222,  500 /
      DATA (WIDTHS(I,  5), I = 109, 112) /  222,  833,  556,  556 /
      DATA (WIDTHS(I,  5), I = 113, 116) /  556,  556,  333,  500 /
      DATA (WIDTHS(I,  5), I = 117, 120) /  278,  556,  500,  722 /
      DATA (WIDTHS(I,  5), I = 121, 124) /  500,  500,  500,  334 /
      DATA (WIDTHS(I,  5), I = 125, 128) /  260,  334,  584,  278 /
      DATA (WIDTHS(I,  5), I = 129, 132) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 133, 136) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 137, 140) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 141, 144) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 145, 148) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 149, 152) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 153, 156) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 157, 160) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 161, 164) /  278,  333,  556,  556 /
      DATA (WIDTHS(I,  5), I = 165, 168) /  556,  556,  260,  556 /
      DATA (WIDTHS(I,  5), I = 169, 172) /  333,  737,  370,  556 /
      DATA (WIDTHS(I,  5), I = 173, 176) /  584,  333,  737,  333 /
      DATA (WIDTHS(I,  5), I = 177, 180) /  400,  584,  333,  333 /
      DATA (WIDTHS(I,  5), I = 181, 184) /  333,  556,  537,  278 /
      DATA (WIDTHS(I,  5), I = 185, 188) /  333,  333,  365,  556 /
      DATA (WIDTHS(I,  5), I = 189, 192) /  834,  834,  834,  611 /
      DATA (WIDTHS(I,  5), I = 193, 196) /  667,  667,  667,  667 /
      DATA (WIDTHS(I,  5), I = 197, 200) /  667,  667, 1000,  722 /
      DATA (WIDTHS(I,  5), I = 201, 204) /  667,  667,  667,  667 /
      DATA (WIDTHS(I,  5), I = 205, 208) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 209, 212) /  722,  722,  778,  778 /
      DATA (WIDTHS(I,  5), I = 213, 216) /  778,  778,  778,  584 /
      DATA (WIDTHS(I,  5), I = 217, 220) /  778,  722,  722,  722 /
      DATA (WIDTHS(I,  5), I = 221, 224) /  722,  667,  667,  611 /
      DATA (WIDTHS(I,  5), I = 225, 228) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  5), I = 229, 232) /  556,  556,  889,  500 /
      DATA (WIDTHS(I,  5), I = 233, 236) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  5), I = 237, 240) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  5), I = 241, 244) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  5), I = 245, 248) /  556,  556,  556,  584 /
      DATA (WIDTHS(I,  5), I = 249, 252) /  611,  556,  556,  556 /
      DATA (WIDTHS(I,  5), I = 253, 256) /  556,  500,  556,  500 /
      DATA (WIDTHS(I,  6), I =   1,   4) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I =   5,   8) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I =   9,  12) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I =  13,  16) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I =  17,  20) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I =  21,  24) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I =  25,  28) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I =  29,  32) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I =  33,  36) /  278,  278,  355,  556 /
      DATA (WIDTHS(I,  6), I =  37,  40) /  556,  889,  667,  222 /
      DATA (WIDTHS(I,  6), I =  41,  44) /  333,  333,  389,  584 /
      DATA (WIDTHS(I,  6), I =  45,  48) /  278,  584,  278,  278 /
      DATA (WIDTHS(I,  6), I =  49,  52) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  6), I =  53,  56) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  6), I =  57,  60) /  556,  556,  278,  278 /
      DATA (WIDTHS(I,  6), I =  61,  64) /  584,  584,  584,  556 /
      DATA (WIDTHS(I,  6), I =  65,  68) / 1015,  667,  667,  722 /
      DATA (WIDTHS(I,  6), I =  69,  72) /  722,  667,  611,  778 /
      DATA (WIDTHS(I,  6), I =  73,  76) /  722,  278,  500,  667 /
      DATA (WIDTHS(I,  6), I =  77,  80) /  556,  833,  722,  778 /
      DATA (WIDTHS(I,  6), I =  81,  84) /  667,  778,  722,  667 /
      DATA (WIDTHS(I,  6), I =  85,  88) /  611,  722,  667,  944 /
      DATA (WIDTHS(I,  6), I =  89,  92) /  667,  667,  611,  278 /
      DATA (WIDTHS(I,  6), I =  93,  96) /  278,  278,  469,  556 /
      DATA (WIDTHS(I,  6), I =  97, 100) /  222,  556,  556,  500 /
      DATA (WIDTHS(I,  6), I = 101, 104) /  556,  556,  278,  556 /
      DATA (WIDTHS(I,  6), I = 105, 108) /  556,  222,  222,  500 /
      DATA (WIDTHS(I,  6), I = 109, 112) /  222,  833,  556,  556 /
      DATA (WIDTHS(I,  6), I = 113, 116) /  556,  556,  333,  500 /
      DATA (WIDTHS(I,  6), I = 117, 120) /  278,  556,  500,  722 /
      DATA (WIDTHS(I,  6), I = 121, 124) /  500,  500,  500,  334 /
      DATA (WIDTHS(I,  6), I = 125, 128) /  260,  334,  584,  278 /
      DATA (WIDTHS(I,  6), I = 129, 132) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 133, 136) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 137, 140) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 141, 144) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 145, 148) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 149, 152) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 153, 156) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 157, 160) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 161, 164) /  278,  333,  556,  556 /
      DATA (WIDTHS(I,  6), I = 165, 168) /  556,  556,  260,  556 /
      DATA (WIDTHS(I,  6), I = 169, 172) /  333,  737,  370,  556 /
      DATA (WIDTHS(I,  6), I = 173, 176) /  584,  333,  737,  333 /
      DATA (WIDTHS(I,  6), I = 177, 180) /  400,  584,  333,  333 /
      DATA (WIDTHS(I,  6), I = 181, 184) /  333,  556,  537,  278 /
      DATA (WIDTHS(I,  6), I = 185, 188) /  333,  333,  365,  556 /
      DATA (WIDTHS(I,  6), I = 189, 192) /  834,  834,  834,  611 /
      DATA (WIDTHS(I,  6), I = 193, 196) /  667,  667,  667,  667 /
      DATA (WIDTHS(I,  6), I = 197, 200) /  667,  667, 1000,  722 /
      DATA (WIDTHS(I,  6), I = 201, 204) /  667,  667,  667,  667 /
      DATA (WIDTHS(I,  6), I = 205, 208) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 209, 212) /  722,  722,  778,  778 /
      DATA (WIDTHS(I,  6), I = 213, 216) /  778,  778,  778,  584 /
      DATA (WIDTHS(I,  6), I = 217, 220) /  778,  722,  722,  722 /
      DATA (WIDTHS(I,  6), I = 221, 224) /  722,  667,  667,  611 /
      DATA (WIDTHS(I,  6), I = 225, 228) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  6), I = 229, 232) /  556,  556,  889,  500 /
      DATA (WIDTHS(I,  6), I = 233, 236) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  6), I = 237, 240) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  6), I = 241, 244) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  6), I = 245, 248) /  556,  556,  556,  584 /
      DATA (WIDTHS(I,  6), I = 249, 252) /  611,  556,  556,  556 /
      DATA (WIDTHS(I,  6), I = 253, 256) /  556,  500,  556,  500 /
      DATA (WIDTHS(I,  7), I =   1,   4) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I =   5,   8) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I =   9,  12) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I =  13,  16) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I =  17,  20) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I =  21,  24) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I =  25,  28) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I =  29,  32) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I =  33,  36) /  278,  333,  474,  556 /
      DATA (WIDTHS(I,  7), I =  37,  40) /  556,  889,  722,  278 /
      DATA (WIDTHS(I,  7), I =  41,  44) /  333,  333,  389,  584 /
      DATA (WIDTHS(I,  7), I =  45,  48) /  278,  584,  278,  278 /
      DATA (WIDTHS(I,  7), I =  49,  52) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  7), I =  53,  56) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  7), I =  57,  60) /  556,  556,  333,  333 /
      DATA (WIDTHS(I,  7), I =  61,  64) /  584,  584,  584,  611 /
      DATA (WIDTHS(I,  7), I =  65,  68) /  975,  722,  722,  722 /
      DATA (WIDTHS(I,  7), I =  69,  72) /  722,  667,  611,  778 /
      DATA (WIDTHS(I,  7), I =  73,  76) /  722,  278,  556,  722 /
      DATA (WIDTHS(I,  7), I =  77,  80) /  611,  833,  722,  778 /
      DATA (WIDTHS(I,  7), I =  81,  84) /  667,  778,  722,  667 /
      DATA (WIDTHS(I,  7), I =  85,  88) /  611,  722,  667,  944 /
      DATA (WIDTHS(I,  7), I =  89,  92) /  667,  667,  611,  333 /
      DATA (WIDTHS(I,  7), I =  93,  96) /  278,  333,  584,  556 /
      DATA (WIDTHS(I,  7), I =  97, 100) /  278,  556,  611,  556 /
      DATA (WIDTHS(I,  7), I = 101, 104) /  611,  556,  333,  611 /
      DATA (WIDTHS(I,  7), I = 105, 108) /  611,  278,  278,  556 /
      DATA (WIDTHS(I,  7), I = 109, 112) /  278,  889,  611,  611 /
      DATA (WIDTHS(I,  7), I = 113, 116) /  611,  611,  389,  556 /
      DATA (WIDTHS(I,  7), I = 117, 120) /  333,  611,  556,  778 /
      DATA (WIDTHS(I,  7), I = 121, 124) /  556,  556,  500,  389 /
      DATA (WIDTHS(I,  7), I = 125, 128) /  280,  389,  584,  278 /
      DATA (WIDTHS(I,  7), I = 129, 132) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 133, 136) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 137, 140) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 141, 144) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 145, 148) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 149, 152) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 153, 156) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 157, 160) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 161, 164) /  278,  333,  556,  556 /
      DATA (WIDTHS(I,  7), I = 165, 168) /  556,  556,  280,  556 /
      DATA (WIDTHS(I,  7), I = 169, 172) /  333,  737,  370,  556 /
      DATA (WIDTHS(I,  7), I = 173, 176) /  584,  333,  737,  333 /
      DATA (WIDTHS(I,  7), I = 177, 180) /  400,  584,  333,  333 /
      DATA (WIDTHS(I,  7), I = 181, 184) /  333,  611,  556,  278 /
      DATA (WIDTHS(I,  7), I = 185, 188) /  333,  333,  365,  556 /
      DATA (WIDTHS(I,  7), I = 189, 192) /  834,  834,  834,  611 /
      DATA (WIDTHS(I,  7), I = 193, 196) /  722,  722,  722,  722 /
      DATA (WIDTHS(I,  7), I = 197, 200) /  722,  722, 1000,  722 /
      DATA (WIDTHS(I,  7), I = 201, 204) /  667,  667,  667,  667 /
      DATA (WIDTHS(I,  7), I = 205, 208) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 209, 212) /  722,  722,  778,  778 /
      DATA (WIDTHS(I,  7), I = 213, 216) /  778,  778,  778,  584 /
      DATA (WIDTHS(I,  7), I = 217, 220) /  778,  722,  722,  722 /
      DATA (WIDTHS(I,  7), I = 221, 224) /  722,  667,  667,  611 /
      DATA (WIDTHS(I,  7), I = 225, 228) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  7), I = 229, 232) /  556,  556,  889,  556 /
      DATA (WIDTHS(I,  7), I = 233, 236) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  7), I = 237, 240) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  7), I = 241, 244) /  611,  611,  611,  611 /
      DATA (WIDTHS(I,  7), I = 245, 248) /  611,  611,  611,  584 /
      DATA (WIDTHS(I,  7), I = 249, 252) /  611,  611,  611,  611 /
      DATA (WIDTHS(I,  7), I = 253, 256) /  611,  556,  611,  556 /
      DATA (WIDTHS(I,  8), I =   1,   4) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I =   5,   8) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I =   9,  12) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I =  13,  16) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I =  17,  20) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I =  21,  24) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I =  25,  28) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I =  29,  32) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I =  33,  36) /  278,  333,  474,  556 /
      DATA (WIDTHS(I,  8), I =  37,  40) /  556,  889,  722,  278 /
      DATA (WIDTHS(I,  8), I =  41,  44) /  333,  333,  389,  584 /
      DATA (WIDTHS(I,  8), I =  45,  48) /  278,  584,  278,  278 /
      DATA (WIDTHS(I,  8), I =  49,  52) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  8), I =  53,  56) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  8), I =  57,  60) /  556,  556,  333,  333 /
      DATA (WIDTHS(I,  8), I =  61,  64) /  584,  584,  584,  611 /
      DATA (WIDTHS(I,  8), I =  65,  68) /  975,  722,  722,  722 /
      DATA (WIDTHS(I,  8), I =  69,  72) /  722,  667,  611,  778 /
      DATA (WIDTHS(I,  8), I =  73,  76) /  722,  278,  556,  722 /
      DATA (WIDTHS(I,  8), I =  77,  80) /  611,  833,  722,  778 /
      DATA (WIDTHS(I,  8), I =  81,  84) /  667,  778,  722,  667 /
      DATA (WIDTHS(I,  8), I =  85,  88) /  611,  722,  667,  944 /
      DATA (WIDTHS(I,  8), I =  89,  92) /  667,  667,  611,  333 /
      DATA (WIDTHS(I,  8), I =  93,  96) /  278,  333,  584,  556 /
      DATA (WIDTHS(I,  8), I =  97, 100) /  278,  556,  611,  556 /
      DATA (WIDTHS(I,  8), I = 101, 104) /  611,  556,  333,  611 /
      DATA (WIDTHS(I,  8), I = 105, 108) /  611,  278,  278,  556 /
      DATA (WIDTHS(I,  8), I = 109, 112) /  278,  889,  611,  611 /
      DATA (WIDTHS(I,  8), I = 113, 116) /  611,  611,  389,  556 /
      DATA (WIDTHS(I,  8), I = 117, 120) /  333,  611,  556,  778 /
      DATA (WIDTHS(I,  8), I = 121, 124) /  556,  556,  500,  389 /
      DATA (WIDTHS(I,  8), I = 125, 128) /  280,  389,  584,  278 /
      DATA (WIDTHS(I,  8), I = 129, 132) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 133, 136) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 137, 140) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 141, 144) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 145, 148) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 149, 152) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 153, 156) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 157, 160) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 161, 164) /  278,  333,  556,  556 /
      DATA (WIDTHS(I,  8), I = 165, 168) /  556,  556,  280,  556 /
      DATA (WIDTHS(I,  8), I = 169, 172) /  333,  737,  370,  556 /
      DATA (WIDTHS(I,  8), I = 173, 176) /  584,  333,  737,  333 /
      DATA (WIDTHS(I,  8), I = 177, 180) /  400,  584,  333,  333 /
      DATA (WIDTHS(I,  8), I = 181, 184) /  333,  611,  556,  278 /
      DATA (WIDTHS(I,  8), I = 185, 188) /  333,  333,  365,  556 /
      DATA (WIDTHS(I,  8), I = 189, 192) /  834,  834,  834,  611 /
      DATA (WIDTHS(I,  8), I = 193, 196) /  722,  722,  722,  722 /
      DATA (WIDTHS(I,  8), I = 197, 200) /  722,  722, 1000,  722 /
      DATA (WIDTHS(I,  8), I = 201, 204) /  667,  667,  667,  667 /
      DATA (WIDTHS(I,  8), I = 205, 208) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 209, 212) /  722,  722,  778,  778 /
      DATA (WIDTHS(I,  8), I = 213, 216) /  778,  778,  778,  584 /
      DATA (WIDTHS(I,  8), I = 217, 220) /  778,  722,  722,  722 /
      DATA (WIDTHS(I,  8), I = 221, 224) /  722,  667,  667,  611 /
      DATA (WIDTHS(I,  8), I = 225, 228) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  8), I = 229, 232) /  556,  556,  889,  556 /
      DATA (WIDTHS(I,  8), I = 233, 236) /  556,  556,  556,  556 /
      DATA (WIDTHS(I,  8), I = 237, 240) /  278,  278,  278,  278 /
      DATA (WIDTHS(I,  8), I = 241, 244) /  611,  611,  611,  611 /
      DATA (WIDTHS(I,  8), I = 245, 248) /  611,  611,  611,  584 /
      DATA (WIDTHS(I,  8), I = 249, 252) /  611,  611,  611,  611 /
      DATA (WIDTHS(I,  8), I = 253, 256) /  611,  556,  611,  556 /
      DATA (WIDTHS(I,  9), I =   1,   4) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =   5,   8) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =   9,  12) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  13,  16) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  17,  20) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  21,  24) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  25,  28) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  29,  32) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  33,  36) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  37,  40) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  41,  44) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  45,  48) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  49,  52) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  53,  56) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  57,  60) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  61,  64) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  65,  68) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  69,  72) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  73,  76) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  77,  80) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  81,  84) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  85,  88) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  89,  92) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  93,  96) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I =  97, 100) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 101, 104) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 105, 108) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 109, 112) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 113, 116) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 117, 120) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 121, 124) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 125, 128) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 129, 132) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 133, 136) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 137, 140) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 141, 144) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 145, 148) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 149, 152) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 153, 156) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 157, 160) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 161, 164) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 165, 168) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 169, 172) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 173, 176) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 177, 180) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 181, 184) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 185, 188) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 189, 192) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 193, 196) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 197, 200) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 201, 204) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 205, 208) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 209, 212) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 213, 216) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 217, 220) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 221, 224) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 225, 228) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 229, 232) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 233, 236) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 237, 240) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 241, 244) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 245, 248) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 249, 252) /  600,  600,  600,  600 /
      DATA (WIDTHS(I,  9), I = 253, 256) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =   1,   4) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =   5,   8) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =   9,  12) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  13,  16) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  17,  20) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  21,  24) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  25,  28) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  29,  32) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  33,  36) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  37,  40) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  41,  44) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  45,  48) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  49,  52) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  53,  56) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  57,  60) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  61,  64) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  65,  68) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  69,  72) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  73,  76) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  77,  80) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  81,  84) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  85,  88) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  89,  92) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  93,  96) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I =  97, 100) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 101, 104) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 105, 108) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 109, 112) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 113, 116) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 117, 120) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 121, 124) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 125, 128) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 129, 132) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 133, 136) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 137, 140) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 141, 144) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 145, 148) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 149, 152) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 153, 156) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 157, 160) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 161, 164) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 165, 168) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 169, 172) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 173, 176) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 177, 180) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 181, 184) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 185, 188) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 189, 192) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 193, 196) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 197, 200) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 201, 204) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 205, 208) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 209, 212) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 213, 216) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 217, 220) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 221, 224) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 225, 228) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 229, 232) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 233, 236) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 237, 240) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 241, 244) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 245, 248) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 249, 252) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 10), I = 253, 256) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =   1,   4) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =   5,   8) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =   9,  12) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  13,  16) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  17,  20) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  21,  24) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  25,  28) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  29,  32) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  33,  36) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  37,  40) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  41,  44) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  45,  48) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  49,  52) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  53,  56) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  57,  60) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  61,  64) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  65,  68) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  69,  72) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  73,  76) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  77,  80) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  81,  84) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  85,  88) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  89,  92) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  93,  96) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I =  97, 100) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 101, 104) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 105, 108) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 109, 112) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 113, 116) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 117, 120) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 121, 124) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 125, 128) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 129, 132) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 133, 136) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 137, 140) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 141, 144) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 145, 148) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 149, 152) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 153, 156) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 157, 160) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 161, 164) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 165, 168) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 169, 172) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 173, 176) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 177, 180) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 181, 184) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 185, 188) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 189, 192) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 193, 196) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 197, 200) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 201, 204) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 205, 208) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 209, 212) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 213, 216) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 217, 220) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 221, 224) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 225, 228) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 229, 232) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 233, 236) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 237, 240) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 241, 244) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 245, 248) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 249, 252) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 11), I = 253, 256) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =   1,   4) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =   5,   8) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =   9,  12) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  13,  16) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  17,  20) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  21,  24) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  25,  28) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  29,  32) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  33,  36) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  37,  40) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  41,  44) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  45,  48) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  49,  52) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  53,  56) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  57,  60) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  61,  64) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  65,  68) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  69,  72) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  73,  76) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  77,  80) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  81,  84) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  85,  88) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  89,  92) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  93,  96) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I =  97, 100) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 101, 104) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 105, 108) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 109, 112) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 113, 116) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 117, 120) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 121, 124) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 125, 128) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 129, 132) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 133, 136) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 137, 140) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 141, 144) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 145, 148) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 149, 152) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 153, 156) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 157, 160) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 161, 164) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 165, 168) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 169, 172) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 173, 176) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 177, 180) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 181, 184) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 185, 188) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 189, 192) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 193, 196) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 197, 200) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 201, 204) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 205, 208) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 209, 212) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 213, 216) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 217, 220) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 221, 224) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 225, 228) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 229, 232) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 233, 236) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 237, 240) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 241, 244) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 245, 248) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 249, 252) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 12), I = 253, 256) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 13), I =   1,   4) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I =   5,   8) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I =   9,  12) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I =  13,  16) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I =  17,  20) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I =  21,  24) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I =  25,  28) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I =  29,  32) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I =  33,  36) /  250,  333,  713,  500 /
      DATA (WIDTHS(I, 13), I =  37,  40) /  549,  833,  778,  439 /
      DATA (WIDTHS(I, 13), I =  41,  44) /  333,  333,  500,  549 /
      DATA (WIDTHS(I, 13), I =  45,  48) /  250,  549,  250,  278 /
      DATA (WIDTHS(I, 13), I =  49,  52) /  500,  500,  500,  500 /
      DATA (WIDTHS(I, 13), I =  53,  56) /  500,  500,  500,  500 /
      DATA (WIDTHS(I, 13), I =  57,  60) /  500,  500,  278,  278 /
      DATA (WIDTHS(I, 13), I =  61,  64) /  549,  549,  549,  444 /
      DATA (WIDTHS(I, 13), I =  65,  68) /  549,  722,  667,  722 /
      DATA (WIDTHS(I, 13), I =  69,  72) /  612,  611,  763,  603 /
      DATA (WIDTHS(I, 13), I =  73,  76) /  722,  333,  631,  722 /
      DATA (WIDTHS(I, 13), I =  77,  80) /  686,  889,  722,  722 /
      DATA (WIDTHS(I, 13), I =  81,  84) /  768,  741,  556,  592 /
      DATA (WIDTHS(I, 13), I =  85,  88) /  611,  690,  439,  768 /
      DATA (WIDTHS(I, 13), I =  89,  92) /  645,  795,  611,  333 /
      DATA (WIDTHS(I, 13), I =  93,  96) /  863,  333,  658,  500 /
      DATA (WIDTHS(I, 13), I =  97, 100) /  500,  631,  549,  549 /
      DATA (WIDTHS(I, 13), I = 101, 104) /  494,  439,  521,  411 /
      DATA (WIDTHS(I, 13), I = 105, 108) /  603,  329,  603,  549 /
      DATA (WIDTHS(I, 13), I = 109, 112) /  549,  576,  521,  549 /
      DATA (WIDTHS(I, 13), I = 113, 116) /  549,  521,  549,  603 /
      DATA (WIDTHS(I, 13), I = 117, 120) /  439,  576,  713,  686 /
      DATA (WIDTHS(I, 13), I = 121, 124) /  493,  686,  494,  480 /
      DATA (WIDTHS(I, 13), I = 125, 128) /  200,  480,  549,  250 /
      DATA (WIDTHS(I, 13), I = 129, 132) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I = 133, 136) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I = 137, 140) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I = 141, 144) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I = 145, 148) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I = 149, 152) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I = 153, 156) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I = 157, 160) /  250,  250,  250,  250 /
      DATA (WIDTHS(I, 13), I = 161, 164) /  250,  620,  247,  549 /
      DATA (WIDTHS(I, 13), I = 165, 168) /  167,  713,  500,  753 /
      DATA (WIDTHS(I, 13), I = 169, 172) /  753,  753,  753, 1042 /
      DATA (WIDTHS(I, 13), I = 173, 176) /  987,  603,  987,  603 /
      DATA (WIDTHS(I, 13), I = 177, 180) /  400,  549,  411,  549 /
      DATA (WIDTHS(I, 13), I = 181, 184) /  549,  713,  494,  460 /
      DATA (WIDTHS(I, 13), I = 185, 188) /  549,  549,  549,  549 /
      DATA (WIDTHS(I, 13), I = 189, 192) / 1000,  603, 1000,  658 /
      DATA (WIDTHS(I, 13), I = 193, 196) /  823,  686,  795,  987 /
      DATA (WIDTHS(I, 13), I = 197, 200) /  768,  768,  823,  768 /
      DATA (WIDTHS(I, 13), I = 201, 204) /  768,  713,  713,  713 /
      DATA (WIDTHS(I, 13), I = 205, 208) /  713,  713,  713,  713 /
      DATA (WIDTHS(I, 13), I = 209, 212) /  768,  713,  790,  790 /
      DATA (WIDTHS(I, 13), I = 213, 216) /  890,  823,  549,  250 /
      DATA (WIDTHS(I, 13), I = 217, 220) /  713,  603,  603, 1042 /
      DATA (WIDTHS(I, 13), I = 221, 224) /  987,  603,  987,  603 /
      DATA (WIDTHS(I, 13), I = 225, 228) /  494,  329,  790,  790 /
      DATA (WIDTHS(I, 13), I = 229, 232) /  786,  713,  384,  384 /
      DATA (WIDTHS(I, 13), I = 233, 236) /  384,  384,  384,  384 /
      DATA (WIDTHS(I, 13), I = 237, 240) /  494,  494,  494,  494 /
      DATA (WIDTHS(I, 13), I = 241, 244) /  250,  329,  274,  686 /
      DATA (WIDTHS(I, 13), I = 245, 248) /  686,  686,  384,  384 /
      DATA (WIDTHS(I, 13), I = 249, 252) /  384,  384,  384,  384 /
      DATA (WIDTHS(I, 13), I = 253, 256) /  494,  494,  494,  250 /
      DATA (WIDTHS(I, 14), I =   1,   4) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I =   5,   8) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I =   9,  12) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I =  13,  16) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I =  17,  20) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I =  21,  24) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I =  25,  28) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I =  29,  32) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I =  33,  36) /  300,  140,  280,  580 /
      DATA (WIDTHS(I, 14), I =  37,  40) /  580,  800,  720,  200 /
      DATA (WIDTHS(I, 14), I =  41,  44) /  340,  340,  340,  660 /
      DATA (WIDTHS(I, 14), I =  45,  48) /  300,  660,  300,  580 /
      DATA (WIDTHS(I, 14), I =  49,  52) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 14), I =  53,  56) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 14), I =  57,  60) /  580,  580,  300,  300 /
      DATA (WIDTHS(I, 14), I =  61,  64) /  660,  660,  660,  520 /
      DATA (WIDTHS(I, 14), I =  65,  68) /  900,  820,  580,  740 /
      DATA (WIDTHS(I, 14), I =  69,  72) /  720,  560,  560,  780 /
      DATA (WIDTHS(I, 14), I =  73,  76) /  720,  300,  520,  700 /
      DATA (WIDTHS(I, 14), I =  77,  80) /  520,  980,  800,  800 /
      DATA (WIDTHS(I, 14), I =  81,  84) /  580,  860,  640,  500 /
      DATA (WIDTHS(I, 14), I =  85,  88) /  540,  700,  780, 1040 /
      DATA (WIDTHS(I, 14), I =  89,  92) /  740,  680,  520,  300 /
      DATA (WIDTHS(I, 14), I =  93,  96) /  580,  300,  660,  500 /
      DATA (WIDTHS(I, 14), I =  97, 100) /  200,  660,  660,  560 /
      DATA (WIDTHS(I, 14), I = 101, 104) /  660,  580,  300,  660 /
      DATA (WIDTHS(I, 14), I = 105, 108) /  640,  260,  240,  580 /
      DATA (WIDTHS(I, 14), I = 109, 112) /  280,  980,  660,  580 /
      DATA (WIDTHS(I, 14), I = 113, 116) /  660,  660,  360,  420 /
      DATA (WIDTHS(I, 14), I = 117, 120) /  320,  640,  640,  900 /
      DATA (WIDTHS(I, 14), I = 121, 124) /  600,  640,  420,  300 /
      DATA (WIDTHS(I, 14), I = 125, 128) /  660,  300,  660,  300 /
      DATA (WIDTHS(I, 14), I = 129, 132) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I = 133, 136) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I = 137, 140) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I = 141, 144) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I = 145, 148) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I = 149, 152) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I = 153, 156) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I = 157, 160) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I = 161, 164) /  300,  140,  580,  580 /
      DATA (WIDTHS(I, 14), I = 165, 168) /  580,  580,  660,  440 /
      DATA (WIDTHS(I, 14), I = 169, 172) /  340,  820,  420,  320 /
      DATA (WIDTHS(I, 14), I = 173, 176) /  660,  300,  820,  460 /
      DATA (WIDTHS(I, 14), I = 177, 180) /  400,  660,  348,  348 /
      DATA (WIDTHS(I, 14), I = 181, 184) /  420,  640,  500,  300 /
      DATA (WIDTHS(I, 14), I = 185, 188) /  320,  348,  340,  320 /
      DATA (WIDTHS(I, 14), I = 189, 192) /  870,  870,  870,  520 /
      DATA (WIDTHS(I, 14), I = 193, 196) /  820,  820,  820,  820 /
      DATA (WIDTHS(I, 14), I = 197, 200) /  820,  820, 1000,  740 /
      DATA (WIDTHS(I, 14), I = 201, 204) /  560,  560,  560,  560 /
      DATA (WIDTHS(I, 14), I = 205, 208) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 14), I = 209, 212) /  720,  800,  800,  800 /
      DATA (WIDTHS(I, 14), I = 213, 216) /  800,  800,  800,  660 /
      DATA (WIDTHS(I, 14), I = 217, 220) /  800,  700,  700,  700 /
      DATA (WIDTHS(I, 14), I = 221, 224) /  700,  680,  580,  580 /
      DATA (WIDTHS(I, 14), I = 225, 228) /  660,  660,  660,  660 /
      DATA (WIDTHS(I, 14), I = 229, 232) /  660,  660, 1060,  560 /
      DATA (WIDTHS(I, 14), I = 233, 236) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 14), I = 237, 240) /  260,  260,  260,  260 /
      DATA (WIDTHS(I, 14), I = 241, 244) /  580,  660,  580,  580 /
      DATA (WIDTHS(I, 14), I = 245, 248) /  580,  580,  580,  660 /
      DATA (WIDTHS(I, 14), I = 249, 252) /  580,  640,  640,  640 /
      DATA (WIDTHS(I, 14), I = 253, 256) /  640,  640,  660,  640 /
      DATA (WIDTHS(I, 15), I =   1,   4) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I =   5,   8) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I =   9,  12) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I =  13,  16) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I =  17,  20) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I =  21,  24) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I =  25,  28) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I =  29,  32) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I =  33,  36) /  300,  140,  280,  580 /
      DATA (WIDTHS(I, 15), I =  37,  40) /  580,  800,  720,  200 /
      DATA (WIDTHS(I, 15), I =  41,  44) /  340,  340,  340,  660 /
      DATA (WIDTHS(I, 15), I =  45,  48) /  300,  660,  300,  580 /
      DATA (WIDTHS(I, 15), I =  49,  52) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 15), I =  53,  56) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 15), I =  57,  60) /  580,  580,  300,  300 /
      DATA (WIDTHS(I, 15), I =  61,  64) /  660,  660,  660,  520 /
      DATA (WIDTHS(I, 15), I =  65,  68) /  900,  820,  580,  740 /
      DATA (WIDTHS(I, 15), I =  69,  72) /  720,  560,  560,  780 /
      DATA (WIDTHS(I, 15), I =  73,  76) /  720,  300,  520,  700 /
      DATA (WIDTHS(I, 15), I =  77,  80) /  520,  980,  800,  800 /
      DATA (WIDTHS(I, 15), I =  81,  84) /  580,  860,  640,  500 /
      DATA (WIDTHS(I, 15), I =  85,  88) /  540,  700,  780, 1040 /
      DATA (WIDTHS(I, 15), I =  89,  92) /  740,  680,  520,  300 /
      DATA (WIDTHS(I, 15), I =  93,  96) /  580,  300,  660,  500 /
      DATA (WIDTHS(I, 15), I =  97, 100) /  200,  660,  660,  560 /
      DATA (WIDTHS(I, 15), I = 101, 104) /  660,  580,  300,  660 /
      DATA (WIDTHS(I, 15), I = 105, 108) /  640,  260,  240,  580 /
      DATA (WIDTHS(I, 15), I = 109, 112) /  280,  980,  660,  580 /
      DATA (WIDTHS(I, 15), I = 113, 116) /  660,  660,  360,  420 /
      DATA (WIDTHS(I, 15), I = 117, 120) /  320,  640,  640,  900 /
      DATA (WIDTHS(I, 15), I = 121, 124) /  600,  640,  420,  300 /
      DATA (WIDTHS(I, 15), I = 125, 128) /  660,  300,  660,  300 /
      DATA (WIDTHS(I, 15), I = 129, 132) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I = 133, 136) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I = 137, 140) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I = 141, 144) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I = 145, 148) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I = 149, 152) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I = 153, 156) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I = 157, 160) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I = 161, 164) /  300,  140,  580,  580 /
      DATA (WIDTHS(I, 15), I = 165, 168) /  580,  580,  660,  440 /
      DATA (WIDTHS(I, 15), I = 169, 172) /  340,  820,  420,  320 /
      DATA (WIDTHS(I, 15), I = 173, 176) /  660,  300,  820,  460 /
      DATA (WIDTHS(I, 15), I = 177, 180) /  400,  660,  348,  348 /
      DATA (WIDTHS(I, 15), I = 181, 184) /  420,  640,  500,  300 /
      DATA (WIDTHS(I, 15), I = 185, 188) /  320,  348,  340,  320 /
      DATA (WIDTHS(I, 15), I = 189, 192) /  870,  870,  870,  520 /
      DATA (WIDTHS(I, 15), I = 193, 196) /  820,  820,  820,  820 /
      DATA (WIDTHS(I, 15), I = 197, 200) /  820,  820, 1000,  740 /
      DATA (WIDTHS(I, 15), I = 201, 204) /  560,  560,  560,  560 /
      DATA (WIDTHS(I, 15), I = 205, 208) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 15), I = 209, 212) /  720,  800,  800,  800 /
      DATA (WIDTHS(I, 15), I = 213, 216) /  800,  800,  800,  660 /
      DATA (WIDTHS(I, 15), I = 217, 220) /  800,  700,  700,  700 /
      DATA (WIDTHS(I, 15), I = 221, 224) /  700,  680,  580,  580 /
      DATA (WIDTHS(I, 15), I = 225, 228) /  660,  660,  660,  660 /
      DATA (WIDTHS(I, 15), I = 229, 232) /  660,  660, 1060,  560 /
      DATA (WIDTHS(I, 15), I = 233, 236) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 15), I = 237, 240) /  260,  260,  260,  260 /
      DATA (WIDTHS(I, 15), I = 241, 244) /  580,  660,  580,  580 /
      DATA (WIDTHS(I, 15), I = 245, 248) /  580,  580,  580,  660 /
      DATA (WIDTHS(I, 15), I = 249, 252) /  580,  640,  640,  640 /
      DATA (WIDTHS(I, 15), I = 253, 256) /  640,  640,  660,  640 /
      DATA (WIDTHS(I, 16), I =   1,   4) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I =   5,   8) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I =   9,  12) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I =  13,  16) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I =  17,  20) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I =  21,  24) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I =  25,  28) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I =  29,  32) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I =  33,  36) /  300,  200,  400,  580 /
      DATA (WIDTHS(I, 16), I =  37,  40) /  580,  860,  720,  200 /
      DATA (WIDTHS(I, 16), I =  41,  44) /  360,  360,  360,  660 /
      DATA (WIDTHS(I, 16), I =  45,  48) /  300,  660,  300,  580 /
      DATA (WIDTHS(I, 16), I =  49,  52) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 16), I =  53,  56) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 16), I =  57,  60) /  580,  580,  300,  300 /
      DATA (WIDTHS(I, 16), I =  61,  64) /  660,  660,  660,  540 /
      DATA (WIDTHS(I, 16), I =  65,  68) /  880,  780,  600,  760 /
      DATA (WIDTHS(I, 16), I =  69,  72) /  740,  580,  580,  780 /
      DATA (WIDTHS(I, 16), I =  73,  76) /  740,  340,  540,  720 /
      DATA (WIDTHS(I, 16), I =  77,  80) /  560,  960,  800,  780 /
      DATA (WIDTHS(I, 16), I =  81,  84) /  600,  860,  640,  520 /
      DATA (WIDTHS(I, 16), I =  85,  88) /  600,  700,  740, 1020 /
      DATA (WIDTHS(I, 16), I =  89,  92) /  740,  680,  560,  380 /
      DATA (WIDTHS(I, 16), I =  93,  96) /  620,  380,  660,  500 /
      DATA (WIDTHS(I, 16), I =  97, 100) /  200,  660,  660,  580 /
      DATA (WIDTHS(I, 16), I = 101, 104) /  660,  580,  320,  660 /
      DATA (WIDTHS(I, 16), I = 105, 108) /  640,  300,  280,  600 /
      DATA (WIDTHS(I, 16), I = 109, 112) /  300,  980,  640,  580 /
      DATA (WIDTHS(I, 16), I = 113, 116) /  660,  660,  380,  460 /
      DATA (WIDTHS(I, 16), I = 117, 120) /  340,  640,  600,  880 /
      DATA (WIDTHS(I, 16), I = 121, 124) /  620,  600,  460,  320 /
      DATA (WIDTHS(I, 16), I = 125, 128) /  660,  320,  660,  300 /
      DATA (WIDTHS(I, 16), I = 129, 132) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I = 133, 136) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I = 137, 140) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I = 141, 144) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I = 145, 148) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I = 149, 152) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I = 153, 156) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I = 157, 160) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I = 161, 164) /  300,  200,  580,  580 /
      DATA (WIDTHS(I, 16), I = 165, 168) /  580,  580,  660,  460 /
      DATA (WIDTHS(I, 16), I = 169, 172) /  460,  820,  420,  360 /
      DATA (WIDTHS(I, 16), I = 173, 176) /  660,  320,  820,  520 /
      DATA (WIDTHS(I, 16), I = 177, 180) /  400,  660,  348,  348 /
      DATA (WIDTHS(I, 16), I = 181, 184) /  460,  640,  540,  300 /
      DATA (WIDTHS(I, 16), I = 185, 188) /  360,  348,  360,  360 /
      DATA (WIDTHS(I, 16), I = 189, 192) /  870,  870,  870,  540 /
      DATA (WIDTHS(I, 16), I = 193, 196) /  780,  780,  780,  780 /
      DATA (WIDTHS(I, 16), I = 197, 200) /  780,  780,  980,  760 /
      DATA (WIDTHS(I, 16), I = 201, 204) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 16), I = 205, 208) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 16), I = 209, 212) /  740,  800,  780,  780 /
      DATA (WIDTHS(I, 16), I = 213, 216) /  780,  780,  780,  660 /
      DATA (WIDTHS(I, 16), I = 217, 220) /  780,  700,  700,  700 /
      DATA (WIDTHS(I, 16), I = 221, 224) /  700,  680,  600,  600 /
      DATA (WIDTHS(I, 16), I = 225, 228) /  660,  660,  660,  660 /
      DATA (WIDTHS(I, 16), I = 229, 232) /  660,  660, 1040,  580 /
      DATA (WIDTHS(I, 16), I = 233, 236) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 16), I = 237, 240) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 16), I = 241, 244) /  580,  640,  580,  580 /
      DATA (WIDTHS(I, 16), I = 245, 248) /  580,  580,  580,  660 /
      DATA (WIDTHS(I, 16), I = 249, 252) /  600,  640,  640,  640 /
      DATA (WIDTHS(I, 16), I = 253, 256) /  640,  600,  660,  600 /
      DATA (WIDTHS(I, 17), I =   1,   4) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I =   5,   8) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I =   9,  12) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I =  13,  16) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I =  17,  20) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I =  21,  24) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I =  25,  28) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I =  29,  32) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I =  33,  36) /  300,  200,  400,  580 /
      DATA (WIDTHS(I, 17), I =  37,  40) /  580,  860,  720,  200 /
      DATA (WIDTHS(I, 17), I =  41,  44) /  360,  360,  360,  660 /
      DATA (WIDTHS(I, 17), I =  45,  48) /  300,  660,  300,  580 /
      DATA (WIDTHS(I, 17), I =  49,  52) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 17), I =  53,  56) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 17), I =  57,  60) /  580,  580,  300,  300 /
      DATA (WIDTHS(I, 17), I =  61,  64) /  660,  660,  660,  540 /
      DATA (WIDTHS(I, 17), I =  65,  68) /  880,  780,  600,  760 /
      DATA (WIDTHS(I, 17), I =  69,  72) /  740,  580,  580,  780 /
      DATA (WIDTHS(I, 17), I =  73,  76) /  740,  340,  540,  720 /
      DATA (WIDTHS(I, 17), I =  77,  80) /  560,  960,  800,  780 /
      DATA (WIDTHS(I, 17), I =  81,  84) /  600,  860,  640,  520 /
      DATA (WIDTHS(I, 17), I =  85,  88) /  600,  700,  740, 1020 /
      DATA (WIDTHS(I, 17), I =  89,  92) /  740,  680,  560,  380 /
      DATA (WIDTHS(I, 17), I =  93,  96) /  620,  380,  660,  500 /
      DATA (WIDTHS(I, 17), I =  97, 100) /  200,  660,  660,  580 /
      DATA (WIDTHS(I, 17), I = 101, 104) /  660,  580,  320,  660 /
      DATA (WIDTHS(I, 17), I = 105, 108) /  640,  300,  280,  600 /
      DATA (WIDTHS(I, 17), I = 109, 112) /  300,  980,  640,  580 /
      DATA (WIDTHS(I, 17), I = 113, 116) /  660,  660,  380,  460 /
      DATA (WIDTHS(I, 17), I = 117, 120) /  340,  640,  600,  880 /
      DATA (WIDTHS(I, 17), I = 121, 124) /  620,  600,  460,  320 /
      DATA (WIDTHS(I, 17), I = 125, 128) /  660,  320,  660,  300 /
      DATA (WIDTHS(I, 17), I = 129, 132) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I = 133, 136) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I = 137, 140) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I = 141, 144) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I = 145, 148) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I = 149, 152) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I = 153, 156) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I = 157, 160) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I = 161, 164) /  300,  200,  580,  580 /
      DATA (WIDTHS(I, 17), I = 165, 168) /  580,  580,  660,  460 /
      DATA (WIDTHS(I, 17), I = 169, 172) /  460,  820,  420,  360 /
      DATA (WIDTHS(I, 17), I = 173, 176) /  660,  320,  820,  520 /
      DATA (WIDTHS(I, 17), I = 177, 180) /  400,  660,  348,  348 /
      DATA (WIDTHS(I, 17), I = 181, 184) /  460,  640,  540,  300 /
      DATA (WIDTHS(I, 17), I = 185, 188) /  360,  348,  360,  360 /
      DATA (WIDTHS(I, 17), I = 189, 192) /  870,  870,  870,  540 /
      DATA (WIDTHS(I, 17), I = 193, 196) /  780,  780,  780,  780 /
      DATA (WIDTHS(I, 17), I = 197, 200) /  780,  780,  980,  760 /
      DATA (WIDTHS(I, 17), I = 201, 204) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 17), I = 205, 208) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 17), I = 209, 212) /  740,  800,  780,  780 /
      DATA (WIDTHS(I, 17), I = 213, 216) /  780,  780,  780,  660 /
      DATA (WIDTHS(I, 17), I = 217, 220) /  780,  700,  700,  700 /
      DATA (WIDTHS(I, 17), I = 221, 224) /  700,  680,  600,  600 /
      DATA (WIDTHS(I, 17), I = 225, 228) /  660,  660,  660,  660 /
      DATA (WIDTHS(I, 17), I = 229, 232) /  660,  660, 1040,  580 /
      DATA (WIDTHS(I, 17), I = 233, 236) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 17), I = 237, 240) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 17), I = 241, 244) /  580,  640,  580,  580 /
      DATA (WIDTHS(I, 17), I = 245, 248) /  580,  580,  580,  660 /
      DATA (WIDTHS(I, 17), I = 249, 252) /  600,  640,  640,  640 /
      DATA (WIDTHS(I, 17), I = 253, 256) /  640,  600,  660,  600 /
      DATA (WIDTHS(I, 18), I =   1,   4) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I =   5,   8) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I =   9,  12) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I =  13,  16) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I =  17,  20) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I =  21,  24) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I =  25,  28) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I =  29,  32) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I =  33,  36) /  278,  296,  389,  556 /
      DATA (WIDTHS(I, 18), I =  37,  40) /  556,  833,  815,  204 /
      DATA (WIDTHS(I, 18), I =  41,  44) /  333,  333,  500,  606 /
      DATA (WIDTHS(I, 18), I =  45,  48) /  278,  606,  278,  278 /
      DATA (WIDTHS(I, 18), I =  49,  52) /  556,  556,  556,  556 /
      DATA (WIDTHS(I, 18), I =  53,  56) /  556,  556,  556,  556 /
      DATA (WIDTHS(I, 18), I =  57,  60) /  556,  556,  278,  278 /
      DATA (WIDTHS(I, 18), I =  61,  64) /  606,  606,  606,  444 /
      DATA (WIDTHS(I, 18), I =  65,  68) /  737,  722,  722,  722 /
      DATA (WIDTHS(I, 18), I =  69,  72) /  778,  722,  667,  778 /
      DATA (WIDTHS(I, 18), I =  73,  76) /  833,  407,  556,  778 /
      DATA (WIDTHS(I, 18), I =  77,  80) /  667,  944,  815,  778 /
      DATA (WIDTHS(I, 18), I =  81,  84) /  667,  778,  722,  630 /
      DATA (WIDTHS(I, 18), I =  85,  88) /  667,  815,  722,  981 /
      DATA (WIDTHS(I, 18), I =  89,  92) /  704,  704,  611,  333 /
      DATA (WIDTHS(I, 18), I =  93,  96) /  606,  333,  606,  500 /
      DATA (WIDTHS(I, 18), I =  97, 100) /  204,  556,  556,  444 /
      DATA (WIDTHS(I, 18), I = 101, 104) /  574,  500,  333,  537 /
      DATA (WIDTHS(I, 18), I = 105, 108) /  611,  315,  296,  593 /
      DATA (WIDTHS(I, 18), I = 109, 112) /  315,  889,  611,  500 /
      DATA (WIDTHS(I, 18), I = 113, 116) /  574,  556,  444,  463 /
      DATA (WIDTHS(I, 18), I = 117, 120) /  389,  611,  537,  778 /
      DATA (WIDTHS(I, 18), I = 121, 124) /  537,  537,  481,  333 /
      DATA (WIDTHS(I, 18), I = 125, 128) /  606,  333,  606,  278 /
      DATA (WIDTHS(I, 18), I = 129, 132) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I = 133, 136) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I = 137, 140) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I = 141, 144) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I = 145, 148) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I = 149, 152) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I = 153, 156) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I = 157, 160) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 18), I = 161, 164) /  278,  296,  556,  556 /
      DATA (WIDTHS(I, 18), I = 165, 168) /  556,  556,  606,  500 /
      DATA (WIDTHS(I, 18), I = 169, 172) /  333,  737,  334,  426 /
      DATA (WIDTHS(I, 18), I = 173, 176) /  606,  333,  737,  333 /
      DATA (WIDTHS(I, 18), I = 177, 180) /  400,  606,  333,  333 /
      DATA (WIDTHS(I, 18), I = 181, 184) /  333,  611,  606,  278 /
      DATA (WIDTHS(I, 18), I = 185, 188) /  333,  333,  300,  426 /
      DATA (WIDTHS(I, 18), I = 189, 192) /  834,  834,  834,  444 /
      DATA (WIDTHS(I, 18), I = 193, 196) /  722,  722,  722,  722 /
      DATA (WIDTHS(I, 18), I = 197, 200) /  722,  722, 1000,  722 /
      DATA (WIDTHS(I, 18), I = 201, 204) /  722,  722,  722,  722 /
      DATA (WIDTHS(I, 18), I = 205, 208) /  407,  407,  407,  407 /
      DATA (WIDTHS(I, 18), I = 209, 212) /  778,  815,  778,  778 /
      DATA (WIDTHS(I, 18), I = 213, 216) /  778,  778,  778,  606 /
      DATA (WIDTHS(I, 18), I = 217, 220) /  778,  815,  815,  815 /
      DATA (WIDTHS(I, 18), I = 221, 224) /  815,  704,  667,  574 /
      DATA (WIDTHS(I, 18), I = 225, 228) /  556,  556,  556,  556 /
      DATA (WIDTHS(I, 18), I = 229, 232) /  556,  556,  796,  444 /
      DATA (WIDTHS(I, 18), I = 233, 236) /  500,  500,  500,  500 /
      DATA (WIDTHS(I, 18), I = 237, 240) /  315,  315,  315,  315 /
      DATA (WIDTHS(I, 18), I = 241, 244) /  500,  611,  500,  500 /
      DATA (WIDTHS(I, 18), I = 245, 248) /  500,  500,  500,  606 /
      DATA (WIDTHS(I, 18), I = 249, 252) /  500,  611,  611,  611 /
      DATA (WIDTHS(I, 18), I = 253, 256) /  611,  537,  574,  537 /
      DATA (WIDTHS(I, 19), I =   1,   4) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I =   5,   8) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I =   9,  12) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I =  13,  16) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I =  17,  20) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I =  21,  24) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I =  25,  28) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I =  29,  32) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I =  33,  36) /  278,  333,  400,  556 /
      DATA (WIDTHS(I, 19), I =  37,  40) /  556,  833,  852,  204 /
      DATA (WIDTHS(I, 19), I =  41,  44) /  333,  333,  500,  606 /
      DATA (WIDTHS(I, 19), I =  45,  48) /  278,  606,  278,  606 /
      DATA (WIDTHS(I, 19), I =  49,  52) /  556,  556,  556,  556 /
      DATA (WIDTHS(I, 19), I =  53,  56) /  556,  556,  556,  556 /
      DATA (WIDTHS(I, 19), I =  57,  60) /  556,  556,  278,  278 /
      DATA (WIDTHS(I, 19), I =  61,  64) /  606,  606,  606,  444 /
      DATA (WIDTHS(I, 19), I =  65,  68) /  747,  704,  722,  722 /
      DATA (WIDTHS(I, 19), I =  69,  72) /  778,  722,  667,  778 /
      DATA (WIDTHS(I, 19), I =  73,  76) /  833,  407,  611,  741 /
      DATA (WIDTHS(I, 19), I =  77,  80) /  667,  944,  815,  778 /
      DATA (WIDTHS(I, 19), I =  81,  84) /  667,  778,  741,  667 /
      DATA (WIDTHS(I, 19), I =  85,  88) /  685,  815,  704,  926 /
      DATA (WIDTHS(I, 19), I =  89,  92) /  704,  685,  667,  333 /
      DATA (WIDTHS(I, 19), I =  93,  96) /  606,  333,  606,  500 /
      DATA (WIDTHS(I, 19), I =  97, 100) /  204,  574,  556,  444 /
      DATA (WIDTHS(I, 19), I = 101, 104) /  611,  444,  333,  537 /
      DATA (WIDTHS(I, 19), I = 105, 108) /  611,  333,  315,  556 /
      DATA (WIDTHS(I, 19), I = 109, 112) /  333,  889,  611,  500 /
      DATA (WIDTHS(I, 19), I = 113, 116) /  574,  556,  444,  444 /
      DATA (WIDTHS(I, 19), I = 117, 120) /  352,  611,  519,  778 /
      DATA (WIDTHS(I, 19), I = 121, 124) /  500,  500,  463,  333 /
      DATA (WIDTHS(I, 19), I = 125, 128) /  606,  333,  606,  278 /
      DATA (WIDTHS(I, 19), I = 129, 132) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I = 133, 136) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I = 137, 140) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I = 141, 144) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I = 145, 148) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I = 149, 152) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I = 153, 156) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I = 157, 160) /  278,  278,  278,  278 /
      DATA (WIDTHS(I, 19), I = 161, 164) /  278,  333,  556,  556 /
      DATA (WIDTHS(I, 19), I = 165, 168) /  556,  556,  606,  500 /
      DATA (WIDTHS(I, 19), I = 169, 172) /  333,  747,  422,  426 /
      DATA (WIDTHS(I, 19), I = 173, 176) /  606,  333,  747,  333 /
      DATA (WIDTHS(I, 19), I = 177, 180) /  400,  606,  333,  333 /
      DATA (WIDTHS(I, 19), I = 181, 184) /  333,  611,  650,  278 /
      DATA (WIDTHS(I, 19), I = 185, 188) /  333,  333,  372,  426 /
      DATA (WIDTHS(I, 19), I = 189, 192) /  834,  834,  834,  444 /
      DATA (WIDTHS(I, 19), I = 193, 196) /  704,  704,  704,  704 /
      DATA (WIDTHS(I, 19), I = 197, 200) /  704,  704,  870,  722 /
      DATA (WIDTHS(I, 19), I = 201, 204) /  722,  722,  722,  722 /
      DATA (WIDTHS(I, 19), I = 205, 208) /  407,  407,  407,  407 /
      DATA (WIDTHS(I, 19), I = 209, 212) /  778,  815,  778,  778 /
      DATA (WIDTHS(I, 19), I = 213, 216) /  778,  778,  778,  606 /
      DATA (WIDTHS(I, 19), I = 217, 220) /  778,  815,  815,  815 /
      DATA (WIDTHS(I, 19), I = 221, 224) /  815,  685,  667,  556 /
      DATA (WIDTHS(I, 19), I = 225, 228) /  574,  574,  574,  574 /
      DATA (WIDTHS(I, 19), I = 229, 232) /  574,  574,  722,  444 /
      DATA (WIDTHS(I, 19), I = 233, 236) /  444,  444,  444,  444 /
      DATA (WIDTHS(I, 19), I = 237, 240) /  333,  333,  333,  333 /
      DATA (WIDTHS(I, 19), I = 241, 244) /  500,  611,  500,  500 /
      DATA (WIDTHS(I, 19), I = 245, 248) /  500,  500,  500,  606 /
      DATA (WIDTHS(I, 19), I = 249, 252) /  500,  611,  611,  611 /
      DATA (WIDTHS(I, 19), I = 253, 256) /  611,  500,  574,  500 /
      DATA (WIDTHS(I, 20), I =   1,   4) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I =   5,   8) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I =   9,  12) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I =  13,  16) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I =  17,  20) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I =  21,  24) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I =  25,  28) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I =  29,  32) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I =  33,  36) /  287,  296,  333,  574 /
      DATA (WIDTHS(I, 20), I =  37,  40) /  574,  833,  852,  241 /
      DATA (WIDTHS(I, 20), I =  41,  44) /  389,  389,  500,  606 /
      DATA (WIDTHS(I, 20), I =  45,  48) /  278,  606,  278,  278 /
      DATA (WIDTHS(I, 20), I =  49,  52) /  574,  574,  574,  574 /
      DATA (WIDTHS(I, 20), I =  53,  56) /  574,  574,  574,  574 /
      DATA (WIDTHS(I, 20), I =  57,  60) /  574,  574,  278,  278 /
      DATA (WIDTHS(I, 20), I =  61,  64) /  606,  606,  606,  500 /
      DATA (WIDTHS(I, 20), I =  65,  68) /  747,  759,  778,  778 /
      DATA (WIDTHS(I, 20), I =  69,  72) /  833,  759,  722,  833 /
      DATA (WIDTHS(I, 20), I =  73,  76) /  870,  444,  648,  815 /
      DATA (WIDTHS(I, 20), I =  77,  80) /  722,  981,  833,  833 /
      DATA (WIDTHS(I, 20), I =  81,  84) /  759,  833,  815,  667 /
      DATA (WIDTHS(I, 20), I =  85,  88) /  722,  833,  759,  981 /
      DATA (WIDTHS(I, 20), I =  89,  92) /  722,  722,  667,  389 /
      DATA (WIDTHS(I, 20), I =  93,  96) /  606,  389,  606,  500 /
      DATA (WIDTHS(I, 20), I =  97, 100) /  241,  611,  648,  556 /
      DATA (WIDTHS(I, 20), I = 101, 104) /  667,  574,  389,  611 /
      DATA (WIDTHS(I, 20), I = 105, 108) /  685,  370,  352,  667 /
      DATA (WIDTHS(I, 20), I = 109, 112) /  352,  963,  685,  611 /
      DATA (WIDTHS(I, 20), I = 113, 116) /  667,  648,  519,  500 /
      DATA (WIDTHS(I, 20), I = 117, 120) /  426,  685,  611,  889 /
      DATA (WIDTHS(I, 20), I = 121, 124) /  611,  611,  537,  389 /
      DATA (WIDTHS(I, 20), I = 125, 128) /  606,  389,  606,  287 /
      DATA (WIDTHS(I, 20), I = 129, 132) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I = 133, 136) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I = 137, 140) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I = 141, 144) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I = 145, 148) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I = 149, 152) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I = 153, 156) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I = 157, 160) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 20), I = 161, 164) /  287,  296,  574,  574 /
      DATA (WIDTHS(I, 20), I = 165, 168) /  574,  574,  606,  500 /
      DATA (WIDTHS(I, 20), I = 169, 172) /  333,  747,  367,  500 /
      DATA (WIDTHS(I, 20), I = 173, 176) /  606,  333,  747,  333 /
      DATA (WIDTHS(I, 20), I = 177, 180) /  400,  606,  344,  344 /
      DATA (WIDTHS(I, 20), I = 181, 184) /  333,  685,  747,  278 /
      DATA (WIDTHS(I, 20), I = 185, 188) /  333,  344,  367,  500 /
      DATA (WIDTHS(I, 20), I = 189, 192) /  861,  861,  861,  500 /
      DATA (WIDTHS(I, 20), I = 193, 196) /  759,  759,  759,  759 /
      DATA (WIDTHS(I, 20), I = 197, 200) /  759,  759,  981,  778 /
      DATA (WIDTHS(I, 20), I = 201, 204) /  759,  759,  759,  759 /
      DATA (WIDTHS(I, 20), I = 205, 208) /  444,  444,  444,  444 /
      DATA (WIDTHS(I, 20), I = 209, 212) /  833,  833,  833,  833 /
      DATA (WIDTHS(I, 20), I = 213, 216) /  833,  833,  833,  606 /
      DATA (WIDTHS(I, 20), I = 217, 220) /  833,  833,  833,  833 /
      DATA (WIDTHS(I, 20), I = 221, 224) /  833,  722,  759,  611 /
      DATA (WIDTHS(I, 20), I = 225, 228) /  611,  611,  611,  611 /
      DATA (WIDTHS(I, 20), I = 229, 232) /  611,  611,  870,  556 /
      DATA (WIDTHS(I, 20), I = 233, 236) /  574,  574,  574,  574 /
      DATA (WIDTHS(I, 20), I = 237, 240) /  370,  370,  370,  370 /
      DATA (WIDTHS(I, 20), I = 241, 244) /  611,  685,  611,  611 /
      DATA (WIDTHS(I, 20), I = 245, 248) /  611,  611,  611,  606 /
      DATA (WIDTHS(I, 20), I = 249, 252) /  611,  685,  685,  685 /
      DATA (WIDTHS(I, 20), I = 253, 256) /  685,  611,  667,  611 /
      DATA (WIDTHS(I, 21), I =   1,   4) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I =   5,   8) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I =   9,  12) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I =  13,  16) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I =  17,  20) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I =  21,  24) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I =  25,  28) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I =  29,  32) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I =  33,  36) /  287,  333,  400,  574 /
      DATA (WIDTHS(I, 21), I =  37,  40) /  574,  889,  889,  259 /
      DATA (WIDTHS(I, 21), I =  41,  44) /  407,  407,  500,  606 /
      DATA (WIDTHS(I, 21), I =  45,  48) /  287,  606,  287,  278 /
      DATA (WIDTHS(I, 21), I =  49,  52) /  574,  574,  574,  574 /
      DATA (WIDTHS(I, 21), I =  53,  56) /  574,  574,  574,  574 /
      DATA (WIDTHS(I, 21), I =  57,  60) /  574,  574,  287,  287 /
      DATA (WIDTHS(I, 21), I =  61,  64) /  606,  606,  606,  481 /
      DATA (WIDTHS(I, 21), I =  65,  68) /  747,  741,  759,  759 /
      DATA (WIDTHS(I, 21), I =  69,  72) /  833,  741,  704,  815 /
      DATA (WIDTHS(I, 21), I =  73,  76) /  870,  444,  667,  778 /
      DATA (WIDTHS(I, 21), I =  77,  80) /  704,  944,  852,  833 /
      DATA (WIDTHS(I, 21), I =  81,  84) /  741,  833,  796,  685 /
      DATA (WIDTHS(I, 21), I =  85,  88) /  722,  833,  741,  944 /
      DATA (WIDTHS(I, 21), I =  89,  92) /  741,  704,  704,  407 /
      DATA (WIDTHS(I, 21), I =  93,  96) /  606,  407,  606,  500 /
      DATA (WIDTHS(I, 21), I =  97, 100) /  259,  667,  611,  537 /
      DATA (WIDTHS(I, 21), I = 101, 104) /  667,  519,  389,  611 /
      DATA (WIDTHS(I, 21), I = 105, 108) /  685,  389,  370,  648 /
      DATA (WIDTHS(I, 21), I = 109, 112) /  389,  944,  685,  574 /
      DATA (WIDTHS(I, 21), I = 113, 116) /  648,  630,  519,  481 /
      DATA (WIDTHS(I, 21), I = 117, 120) /  407,  685,  556,  833 /
      DATA (WIDTHS(I, 21), I = 121, 124) /  574,  519,  519,  407 /
      DATA (WIDTHS(I, 21), I = 125, 128) /  606,  407,  606,  287 /
      DATA (WIDTHS(I, 21), I = 129, 132) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I = 133, 136) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I = 137, 140) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I = 141, 144) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I = 145, 148) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I = 149, 152) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I = 153, 156) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I = 157, 160) /  287,  287,  287,  287 /
      DATA (WIDTHS(I, 21), I = 161, 164) /  287,  333,  574,  574 /
      DATA (WIDTHS(I, 21), I = 165, 168) /  574,  574,  606,  500 /
      DATA (WIDTHS(I, 21), I = 169, 172) /  333,  747,  412,  481 /
      DATA (WIDTHS(I, 21), I = 173, 176) /  606,  333,  747,  333 /
      DATA (WIDTHS(I, 21), I = 177, 180) /  400,  606,  344,  344 /
      DATA (WIDTHS(I, 21), I = 181, 184) /  333,  685,  650,  287 /
      DATA (WIDTHS(I, 21), I = 185, 188) /  333,  344,  356,  481 /
      DATA (WIDTHS(I, 21), I = 189, 192) /  861,  861,  861,  481 /
      DATA (WIDTHS(I, 21), I = 193, 196) /  741,  741,  741,  741 /
      DATA (WIDTHS(I, 21), I = 197, 200) /  741,  741,  889,  759 /
      DATA (WIDTHS(I, 21), I = 201, 204) /  741,  741,  741,  741 /
      DATA (WIDTHS(I, 21), I = 205, 208) /  444,  444,  444,  444 /
      DATA (WIDTHS(I, 21), I = 209, 212) /  833,  852,  833,  833 /
      DATA (WIDTHS(I, 21), I = 213, 216) /  833,  833,  833,  606 /
      DATA (WIDTHS(I, 21), I = 217, 220) /  833,  833,  833,  833 /
      DATA (WIDTHS(I, 21), I = 221, 224) /  833,  704,  741,  574 /
      DATA (WIDTHS(I, 21), I = 225, 228) /  667,  667,  667,  667 /
      DATA (WIDTHS(I, 21), I = 229, 232) /  667,  667,  815,  537 /
      DATA (WIDTHS(I, 21), I = 233, 236) /  519,  519,  519,  519 /
      DATA (WIDTHS(I, 21), I = 237, 240) /  389,  389,  389,  389 /
      DATA (WIDTHS(I, 21), I = 241, 244) /  574,  685,  574,  574 /
      DATA (WIDTHS(I, 21), I = 245, 248) /  574,  574,  574,  606 /
      DATA (WIDTHS(I, 21), I = 249, 252) /  574,  685,  685,  685 /
      DATA (WIDTHS(I, 21), I = 253, 256) /  685,  519,  648,  519 /
      DATA (WIDTHS(I, 22), I =   1,   4) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I =   5,   8) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I =   9,  12) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I =  13,  16) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I =  17,  20) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I =  21,  24) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I =  25,  28) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I =  29,  32) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I =  33,  36) /  277,  295,  309,  554 /
      DATA (WIDTHS(I, 22), I =  37,  40) /  554,  775,  757,  351 /
      DATA (WIDTHS(I, 22), I =  41,  44) /  369,  369,  425,  606 /
      DATA (WIDTHS(I, 22), I =  45,  48) /  277,  606,  277,  437 /
      DATA (WIDTHS(I, 22), I =  49,  52) /  554,  554,  554,  554 /
      DATA (WIDTHS(I, 22), I =  53,  56) /  554,  554,  554,  554 /
      DATA (WIDTHS(I, 22), I =  57,  60) /  554,  554,  277,  277 /
      DATA (WIDTHS(I, 22), I =  61,  64) /  606,  606,  606,  591 /
      DATA (WIDTHS(I, 22), I =  65,  68) /  867,  740,  574,  813 /
      DATA (WIDTHS(I, 22), I =  69,  72) /  744,  536,  485,  872 /
      DATA (WIDTHS(I, 22), I =  73,  76) /  683,  226,  482,  591 /
      DATA (WIDTHS(I, 22), I =  77,  80) /  462,  919,  740,  869 /
      DATA (WIDTHS(I, 22), I =  81,  84) /  592,  871,  607,  498 /
      DATA (WIDTHS(I, 22), I =  85,  88) /  426,  655,  702,  960 /
      DATA (WIDTHS(I, 22), I =  89,  92) /  609,  592,  480,  351 /
      DATA (WIDTHS(I, 22), I =  93,  96) /  605,  351,  606,  500 /
      DATA (WIDTHS(I, 22), I =  97, 100) /  351,  683,  682,  647 /
      DATA (WIDTHS(I, 22), I = 101, 104) /  685,  650,  314,  673 /
      DATA (WIDTHS(I, 22), I = 105, 108) /  610,  200,  203,  502 /
      DATA (WIDTHS(I, 22), I = 109, 112) /  200,  938,  610,  655 /
      DATA (WIDTHS(I, 22), I = 113, 116) /  682,  682,  301,  388 /
      DATA (WIDTHS(I, 22), I = 117, 120) /  339,  608,  554,  831 /
      DATA (WIDTHS(I, 22), I = 121, 124) /  480,  536,  425,  351 /
      DATA (WIDTHS(I, 22), I = 125, 128) /  672,  351,  606,  277 /
      DATA (WIDTHS(I, 22), I = 129, 132) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I = 133, 136) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I = 137, 140) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I = 141, 144) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I = 145, 148) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I = 149, 152) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I = 153, 156) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I = 157, 160) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 22), I = 161, 164) /  277,  295,  554,  554 /
      DATA (WIDTHS(I, 22), I = 165, 168) /  554,  554,  672,  615 /
      DATA (WIDTHS(I, 22), I = 169, 172) /  369,  747,  369,  425 /
      DATA (WIDTHS(I, 22), I = 173, 176) /  606,  332,  747,  485 /
      DATA (WIDTHS(I, 22), I = 177, 180) /  400,  606,  332,  332 /
      DATA (WIDTHS(I, 22), I = 181, 184) /  375,  608,  564,  277 /
      DATA (WIDTHS(I, 22), I = 185, 188) /  324,  332,  369,  425 /
      DATA (WIDTHS(I, 22), I = 189, 192) /  831,  831,  831,  591 /
      DATA (WIDTHS(I, 22), I = 193, 196) /  740,  740,  740,  740 /
      DATA (WIDTHS(I, 22), I = 197, 200) /  740,  740,  992,  813 /
      DATA (WIDTHS(I, 22), I = 201, 204) /  536,  536,  536,  536 /
      DATA (WIDTHS(I, 22), I = 205, 208) /  226,  226,  226,  226 /
      DATA (WIDTHS(I, 22), I = 209, 212) /  790,  740,  869,  869 /
      DATA (WIDTHS(I, 22), I = 213, 216) /  869,  869,  869,  606 /
      DATA (WIDTHS(I, 22), I = 217, 220) /  868,  655,  655,  655 /
      DATA (WIDTHS(I, 22), I = 221, 224) /  655,  592,  592,  554 /
      DATA (WIDTHS(I, 22), I = 225, 228) /  683,  683,  683,  683 /
      DATA (WIDTHS(I, 22), I = 229, 232) /  683,  683, 1157,  647 /
      DATA (WIDTHS(I, 22), I = 233, 236) /  650,  650,  650,  650 /
      DATA (WIDTHS(I, 22), I = 237, 240) /  200,  200,  200,  200 /
      DATA (WIDTHS(I, 22), I = 241, 244) /  655,  610,  655,  655 /
      DATA (WIDTHS(I, 22), I = 245, 248) /  655,  655,  655,  606 /
      DATA (WIDTHS(I, 22), I = 249, 252) /  653,  608,  608,  608 /
      DATA (WIDTHS(I, 22), I = 253, 256) /  608,  536,  682,  536 /
      DATA (WIDTHS(I, 23), I =   1,   4) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I =   5,   8) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I =   9,  12) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I =  13,  16) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I =  17,  20) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I =  21,  24) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I =  25,  28) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I =  29,  32) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I =  33,  36) /  277,  295,  309,  554 /
      DATA (WIDTHS(I, 23), I =  37,  40) /  554,  775,  757,  351 /
      DATA (WIDTHS(I, 23), I =  41,  44) /  369,  369,  425,  606 /
      DATA (WIDTHS(I, 23), I =  45,  48) /  277,  606,  277,  437 /
      DATA (WIDTHS(I, 23), I =  49,  52) /  554,  554,  554,  554 /
      DATA (WIDTHS(I, 23), I =  53,  56) /  554,  554,  554,  554 /
      DATA (WIDTHS(I, 23), I =  57,  60) /  554,  554,  277,  277 /
      DATA (WIDTHS(I, 23), I =  61,  64) /  606,  606,  606,  591 /
      DATA (WIDTHS(I, 23), I =  65,  68) /  867,  740,  574,  813 /
      DATA (WIDTHS(I, 23), I =  69,  72) /  744,  536,  485,  872 /
      DATA (WIDTHS(I, 23), I =  73,  76) /  683,  226,  482,  591 /
      DATA (WIDTHS(I, 23), I =  77,  80) /  462,  919,  740,  869 /
      DATA (WIDTHS(I, 23), I =  81,  84) /  592,  871,  607,  498 /
      DATA (WIDTHS(I, 23), I =  85,  88) /  426,  655,  702,  960 /
      DATA (WIDTHS(I, 23), I =  89,  92) /  609,  592,  480,  351 /
      DATA (WIDTHS(I, 23), I =  93,  96) /  605,  351,  606,  500 /
      DATA (WIDTHS(I, 23), I =  97, 100) /  351,  683,  682,  647 /
      DATA (WIDTHS(I, 23), I = 101, 104) /  685,  650,  314,  673 /
      DATA (WIDTHS(I, 23), I = 105, 108) /  610,  200,  203,  502 /
      DATA (WIDTHS(I, 23), I = 109, 112) /  200,  938,  610,  655 /
      DATA (WIDTHS(I, 23), I = 113, 116) /  682,  682,  301,  388 /
      DATA (WIDTHS(I, 23), I = 117, 120) /  339,  608,  554,  831 /
      DATA (WIDTHS(I, 23), I = 121, 124) /  480,  536,  425,  351 /
      DATA (WIDTHS(I, 23), I = 125, 128) /  672,  351,  606,  277 /
      DATA (WIDTHS(I, 23), I = 129, 132) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I = 133, 136) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I = 137, 140) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I = 141, 144) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I = 145, 148) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I = 149, 152) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I = 153, 156) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I = 157, 160) /  277,  277,  277,  277 /
      DATA (WIDTHS(I, 23), I = 161, 164) /  277,  295,  554,  554 /
      DATA (WIDTHS(I, 23), I = 165, 168) /  554,  554,  672,  615 /
      DATA (WIDTHS(I, 23), I = 169, 172) /  369,  747,  369,  425 /
      DATA (WIDTHS(I, 23), I = 173, 176) /  606,  332,  747,  485 /
      DATA (WIDTHS(I, 23), I = 177, 180) /  400,  606,  332,  332 /
      DATA (WIDTHS(I, 23), I = 181, 184) /  375,  608,  564,  277 /
      DATA (WIDTHS(I, 23), I = 185, 188) /  324,  332,  369,  425 /
      DATA (WIDTHS(I, 23), I = 189, 192) /  831,  831,  831,  591 /
      DATA (WIDTHS(I, 23), I = 193, 196) /  740,  740,  740,  740 /
      DATA (WIDTHS(I, 23), I = 197, 200) /  740,  740,  992,  813 /
      DATA (WIDTHS(I, 23), I = 201, 204) /  536,  536,  536,  536 /
      DATA (WIDTHS(I, 23), I = 205, 208) /  226,  226,  226,  226 /
      DATA (WIDTHS(I, 23), I = 209, 212) /  790,  740,  869,  869 /
      DATA (WIDTHS(I, 23), I = 213, 216) /  869,  869,  869,  606 /
      DATA (WIDTHS(I, 23), I = 217, 220) /  868,  655,  655,  655 /
      DATA (WIDTHS(I, 23), I = 221, 224) /  655,  592,  592,  554 /
      DATA (WIDTHS(I, 23), I = 225, 228) /  683,  683,  683,  683 /
      DATA (WIDTHS(I, 23), I = 229, 232) /  683,  683, 1157,  647 /
      DATA (WIDTHS(I, 23), I = 233, 236) /  650,  650,  650,  650 /
      DATA (WIDTHS(I, 23), I = 237, 240) /  200,  200,  200,  200 /
      DATA (WIDTHS(I, 23), I = 241, 244) /  655,  610,  655,  655 /
      DATA (WIDTHS(I, 23), I = 245, 248) /  655,  655,  655,  606 /
      DATA (WIDTHS(I, 23), I = 249, 252) /  653,  608,  608,  608 /
      DATA (WIDTHS(I, 23), I = 253, 256) /  608,  536,  682,  536 /
      DATA (WIDTHS(I, 24), I =   1,   4) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I =   5,   8) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I =   9,  12) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I =  13,  16) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I =  17,  20) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I =  21,  24) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I =  25,  28) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I =  29,  32) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I =  33,  36) /  280,  280,  360,  560 /
      DATA (WIDTHS(I, 24), I =  37,  40) /  560,  860,  680,  280 /
      DATA (WIDTHS(I, 24), I =  41,  44) /  380,  380,  440,  600 /
      DATA (WIDTHS(I, 24), I =  45,  48) /  280,  600,  280,  460 /
      DATA (WIDTHS(I, 24), I =  49,  52) /  560,  560,  560,  560 /
      DATA (WIDTHS(I, 24), I =  53,  56) /  560,  560,  560,  560 /
      DATA (WIDTHS(I, 24), I =  57,  60) /  560,  560,  280,  280 /
      DATA (WIDTHS(I, 24), I =  61,  64) /  600,  600,  600,  560 /
      DATA (WIDTHS(I, 24), I =  65,  68) /  740,  740,  580,  780 /
      DATA (WIDTHS(I, 24), I =  69,  72) /  700,  520,  480,  840 /
      DATA (WIDTHS(I, 24), I =  73,  76) /  680,  280,  480,  620 /
      DATA (WIDTHS(I, 24), I =  77,  80) /  440,  900,  740,  840 /
      DATA (WIDTHS(I, 24), I =  81,  84) /  560,  840,  580,  520 /
      DATA (WIDTHS(I, 24), I =  85,  88) /  420,  640,  700,  900 /
      DATA (WIDTHS(I, 24), I =  89,  92) /  680,  620,  500,  320 /
      DATA (WIDTHS(I, 24), I =  93,  96) /  640,  320,  600,  500 /
      DATA (WIDTHS(I, 24), I =  97, 100) /  280,  660,  660,  640 /
      DATA (WIDTHS(I, 24), I = 101, 104) /  660,  640,  280,  660 /
      DATA (WIDTHS(I, 24), I = 105, 108) /  600,  240,  260,  580 /
      DATA (WIDTHS(I, 24), I = 109, 112) /  240,  940,  600,  640 /
      DATA (WIDTHS(I, 24), I = 113, 116) /  660,  660,  320,  440 /
      DATA (WIDTHS(I, 24), I = 117, 120) /  300,  600,  560,  800 /
      DATA (WIDTHS(I, 24), I = 121, 124) /  560,  580,  460,  340 /
      DATA (WIDTHS(I, 24), I = 125, 128) /  600,  340,  600,  280 /
      DATA (WIDTHS(I, 24), I = 129, 132) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I = 133, 136) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I = 137, 140) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I = 141, 144) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I = 145, 148) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I = 149, 152) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I = 153, 156) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I = 157, 160) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I = 161, 164) /  280,  280,  560,  560 /
      DATA (WIDTHS(I, 24), I = 165, 168) /  560,  560,  600,  560 /
      DATA (WIDTHS(I, 24), I = 169, 172) /  500,  740,  360,  460 /
      DATA (WIDTHS(I, 24), I = 173, 176) /  600,  420,  740,  420 /
      DATA (WIDTHS(I, 24), I = 177, 180) /  400,  600,  336,  336 /
      DATA (WIDTHS(I, 24), I = 181, 184) /  420,  576,  600,  280 /
      DATA (WIDTHS(I, 24), I = 185, 188) /  340,  336,  360,  460 /
      DATA (WIDTHS(I, 24), I = 189, 192) /  840,  840,  840,  560 /
      DATA (WIDTHS(I, 24), I = 193, 196) /  740,  740,  740,  740 /
      DATA (WIDTHS(I, 24), I = 197, 200) /  740,  740,  900,  780 /
      DATA (WIDTHS(I, 24), I = 201, 204) /  520,  520,  520,  520 /
      DATA (WIDTHS(I, 24), I = 205, 208) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 24), I = 209, 212) /  742,  740,  840,  840 /
      DATA (WIDTHS(I, 24), I = 213, 216) /  840,  840,  840,  600 /
      DATA (WIDTHS(I, 24), I = 217, 220) /  840,  640,  640,  640 /
      DATA (WIDTHS(I, 24), I = 221, 224) /  640,  620,  560,  600 /
      DATA (WIDTHS(I, 24), I = 225, 228) /  660,  660,  660,  660 /
      DATA (WIDTHS(I, 24), I = 229, 232) /  660,  660, 1080,  640 /
      DATA (WIDTHS(I, 24), I = 233, 236) /  640,  640,  640,  640 /
      DATA (WIDTHS(I, 24), I = 237, 240) /  240,  240,  240,  240 /
      DATA (WIDTHS(I, 24), I = 241, 244) /  640,  600,  640,  640 /
      DATA (WIDTHS(I, 24), I = 245, 248) /  640,  640,  640,  600 /
      DATA (WIDTHS(I, 24), I = 249, 252) /  660,  600,  600,  600 /
      DATA (WIDTHS(I, 24), I = 253, 256) /  600,  580,  660,  580 /
      DATA (WIDTHS(I, 25), I =   1,   4) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I =   5,   8) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I =   9,  12) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I =  13,  16) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I =  17,  20) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I =  21,  24) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I =  25,  28) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I =  29,  32) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I =  33,  36) /  280,  280,  360,  560 /
      DATA (WIDTHS(I, 25), I =  37,  40) /  560,  860,  680,  280 /
      DATA (WIDTHS(I, 25), I =  41,  44) /  380,  380,  440,  600 /
      DATA (WIDTHS(I, 25), I =  45,  48) /  280,  600,  280,  460 /
      DATA (WIDTHS(I, 25), I =  49,  52) /  560,  560,  560,  560 /
      DATA (WIDTHS(I, 25), I =  53,  56) /  560,  560,  560,  560 /
      DATA (WIDTHS(I, 25), I =  57,  60) /  560,  560,  280,  280 /
      DATA (WIDTHS(I, 25), I =  61,  64) /  600,  600,  600,  560 /
      DATA (WIDTHS(I, 25), I =  65,  68) /  740,  740,  580,  780 /
      DATA (WIDTHS(I, 25), I =  69,  72) /  700,  520,  480,  840 /
      DATA (WIDTHS(I, 25), I =  73,  76) /  680,  280,  480,  620 /
      DATA (WIDTHS(I, 25), I =  77,  80) /  440,  900,  740,  840 /
      DATA (WIDTHS(I, 25), I =  81,  84) /  560,  840,  580,  520 /
      DATA (WIDTHS(I, 25), I =  85,  88) /  420,  640,  700,  900 /
      DATA (WIDTHS(I, 25), I =  89,  92) /  680,  620,  500,  320 /
      DATA (WIDTHS(I, 25), I =  93,  96) /  640,  320,  600,  500 /
      DATA (WIDTHS(I, 25), I =  97, 100) /  280,  660,  660,  640 /
      DATA (WIDTHS(I, 25), I = 101, 104) /  660,  640,  280,  660 /
      DATA (WIDTHS(I, 25), I = 105, 108) /  600,  240,  260,  580 /
      DATA (WIDTHS(I, 25), I = 109, 112) /  240,  940,  600,  640 /
      DATA (WIDTHS(I, 25), I = 113, 116) /  660,  660,  320,  440 /
      DATA (WIDTHS(I, 25), I = 117, 120) /  300,  600,  560,  800 /
      DATA (WIDTHS(I, 25), I = 121, 124) /  560,  580,  460,  340 /
      DATA (WIDTHS(I, 25), I = 125, 128) /  600,  340,  600,  280 /
      DATA (WIDTHS(I, 25), I = 129, 132) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I = 133, 136) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I = 137, 140) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I = 141, 144) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I = 145, 148) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I = 149, 152) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I = 153, 156) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I = 157, 160) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I = 161, 164) /  280,  280,  560,  560 /
      DATA (WIDTHS(I, 25), I = 165, 168) /  560,  560,  600,  560 /
      DATA (WIDTHS(I, 25), I = 169, 172) /  500,  740,  360,  460 /
      DATA (WIDTHS(I, 25), I = 173, 176) /  600,  420,  740,  420 /
      DATA (WIDTHS(I, 25), I = 177, 180) /  400,  600,  336,  336 /
      DATA (WIDTHS(I, 25), I = 181, 184) /  420,  576,  600,  280 /
      DATA (WIDTHS(I, 25), I = 185, 188) /  340,  336,  360,  460 /
      DATA (WIDTHS(I, 25), I = 189, 192) /  840,  840,  840,  560 /
      DATA (WIDTHS(I, 25), I = 193, 196) /  740,  740,  740,  740 /
      DATA (WIDTHS(I, 25), I = 197, 200) /  740,  740,  900,  780 /
      DATA (WIDTHS(I, 25), I = 201, 204) /  520,  520,  520,  520 /
      DATA (WIDTHS(I, 25), I = 205, 208) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 25), I = 209, 212) /  742,  740,  840,  840 /
      DATA (WIDTHS(I, 25), I = 213, 216) /  840,  840,  840,  600 /
      DATA (WIDTHS(I, 25), I = 217, 220) /  840,  640,  640,  640 /
      DATA (WIDTHS(I, 25), I = 221, 224) /  640,  620,  560,  600 /
      DATA (WIDTHS(I, 25), I = 225, 228) /  660,  660,  660,  660 /
      DATA (WIDTHS(I, 25), I = 229, 232) /  660,  660, 1080,  640 /
      DATA (WIDTHS(I, 25), I = 233, 236) /  640,  640,  640,  640 /
      DATA (WIDTHS(I, 25), I = 237, 240) /  240,  240,  240,  240 /
      DATA (WIDTHS(I, 25), I = 241, 244) /  640,  600,  640,  640 /
      DATA (WIDTHS(I, 25), I = 245, 248) /  640,  640,  640,  600 /
      DATA (WIDTHS(I, 25), I = 249, 252) /  660,  600,  600,  600 /
      DATA (WIDTHS(I, 25), I = 253, 256) /  600,  580,  660,  580 /
      DATA (WIDTHS(I, 26), I =   1,   4) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I =   5,   8) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I =   9,  12) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I =  13,  16) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I =  17,  20) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I =  21,  24) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I =  25,  28) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I =  29,  32) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I =  33,  36) /  300,  300,  360,  600 /
      DATA (WIDTHS(I, 26), I =  37,  40) /  600,  820,  800,  280 /
      DATA (WIDTHS(I, 26), I =  41,  44) /  240,  240,  360,  660 /
      DATA (WIDTHS(I, 26), I =  45,  48) /  300,  660,  300,  520 /
      DATA (WIDTHS(I, 26), I =  49,  52) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 26), I =  53,  56) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 26), I =  57,  60) /  600,  600,  300,  300 /
      DATA (WIDTHS(I, 26), I =  61,  64) /  660,  660,  660,  460 /
      DATA (WIDTHS(I, 26), I =  65,  68) /  820,  720,  680,  720 /
      DATA (WIDTHS(I, 26), I =  69,  72) /  740,  600,  560,  760 /
      DATA (WIDTHS(I, 26), I =  73,  76) /  800,  260,  480,  700 /
      DATA (WIDTHS(I, 26), I =  77,  80) /  600,  860,  740,  800 /
      DATA (WIDTHS(I, 26), I =  81,  84) /  620,  800,  680,  600 /
      DATA (WIDTHS(I, 26), I =  85,  88) /  640,  760,  700,  940 /
      DATA (WIDTHS(I, 26), I =  89,  92) /  700,  700,  580,  240 /
      DATA (WIDTHS(I, 26), I =  93,  96) /  600,  240,  660,  500 /
      DATA (WIDTHS(I, 26), I =  97, 100) /  280,  500,  520,  460 /
      DATA (WIDTHS(I, 26), I = 101, 104) /  520,  500,  300,  520 /
      DATA (WIDTHS(I, 26), I = 105, 108) /  560,  240,  220,  500 /
      DATA (WIDTHS(I, 26), I = 109, 112) /  220,  840,  560,  560 /
      DATA (WIDTHS(I, 26), I = 113, 116) /  580,  520,  360,  400 /
      DATA (WIDTHS(I, 26), I = 117, 120) /  300,  520,  460,  720 /
      DATA (WIDTHS(I, 26), I = 121, 124) /  500,  480,  420,  300 /
      DATA (WIDTHS(I, 26), I = 125, 128) /  660,  300,  660,  300 /
      DATA (WIDTHS(I, 26), I = 129, 132) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I = 133, 136) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I = 137, 140) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I = 141, 144) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I = 145, 148) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I = 149, 152) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I = 153, 156) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I = 157, 160) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 26), I = 161, 164) /  300,  300,  600,  600 /
      DATA (WIDTHS(I, 26), I = 165, 168) /  600,  600,  660,  520 /
      DATA (WIDTHS(I, 26), I = 169, 172) /  460,  840,  400,  340 /
      DATA (WIDTHS(I, 26), I = 173, 176) /  660,  300,  800,  380 /
      DATA (WIDTHS(I, 26), I = 177, 180) /  400,  660,  360,  360 /
      DATA (WIDTHS(I, 26), I = 181, 184) /  320,  520,  720,  300 /
      DATA (WIDTHS(I, 26), I = 185, 188) /  300,  360,  400,  340 /
      DATA (WIDTHS(I, 26), I = 189, 192) /  900,  900,  900,  460 /
      DATA (WIDTHS(I, 26), I = 193, 196) /  720,  720,  720,  720 /
      DATA (WIDTHS(I, 26), I = 197, 200) /  720,  720,  960,  720 /
      DATA (WIDTHS(I, 26), I = 201, 204) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 26), I = 205, 208) /  260,  260,  260,  260 /
      DATA (WIDTHS(I, 26), I = 209, 212) /  740,  740,  800,  800 /
      DATA (WIDTHS(I, 26), I = 213, 216) /  800,  800,  800,  660 /
      DATA (WIDTHS(I, 26), I = 217, 220) /  800,  760,  760,  760 /
      DATA (WIDTHS(I, 26), I = 221, 224) /  760,  700,  620,  520 /
      DATA (WIDTHS(I, 26), I = 225, 228) /  500,  500,  500,  500 /
      DATA (WIDTHS(I, 26), I = 229, 232) /  500,  500,  800,  460 /
      DATA (WIDTHS(I, 26), I = 233, 236) /  500,  500,  500,  500 /
      DATA (WIDTHS(I, 26), I = 237, 240) /  240,  240,  240,  240 /
      DATA (WIDTHS(I, 26), I = 241, 244) /  570,  560,  560,  560 /
      DATA (WIDTHS(I, 26), I = 245, 248) /  560,  560,  560,  660 /
      DATA (WIDTHS(I, 26), I = 249, 252) /  560,  520,  520,  520 /
      DATA (WIDTHS(I, 26), I = 253, 256) /  520,  480,  580,  480 /
      DATA (WIDTHS(I, 27), I =   1,   4) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I =   5,   8) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I =   9,  12) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I =  13,  16) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I =  17,  20) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I =  21,  24) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I =  25,  28) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I =  29,  32) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I =  33,  36) /  300,  300,  360,  600 /
      DATA (WIDTHS(I, 27), I =  37,  40) /  600,  900,  820,  300 /
      DATA (WIDTHS(I, 27), I =  41,  44) /  260,  260,  540,  660 /
      DATA (WIDTHS(I, 27), I =  45,  48) /  300,  660,  300,  220 /
      DATA (WIDTHS(I, 27), I =  49,  52) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 27), I =  53,  56) /  600,  600,  600,  600 /
      DATA (WIDTHS(I, 27), I =  57,  60) /  600,  600,  300,  300 /
      DATA (WIDTHS(I, 27), I =  61,  64) /  660,  660,  660,  420 /
      DATA (WIDTHS(I, 27), I =  65,  68) /  820,  740,  680,  720 /
      DATA (WIDTHS(I, 27), I =  69,  72) /  760,  660,  580,  760 /
      DATA (WIDTHS(I, 27), I =  73,  76) /  820,  300,  500,  700 /
      DATA (WIDTHS(I, 27), I =  77,  80) /  640,  880,  780,  780 /
      DATA (WIDTHS(I, 27), I =  81,  84) /  640,  780,  700,  620 /
      DATA (WIDTHS(I, 27), I =  85,  88) /  660,  760,  700,  980 /
      DATA (WIDTHS(I, 27), I =  89,  92) /  740,  740,  580,  220 /
      DATA (WIDTHS(I, 27), I =  93,  96) /  600,  220,  660,  500 /
      DATA (WIDTHS(I, 27), I =  97, 100) /  300,  520,  540,  460 /
      DATA (WIDTHS(I, 27), I = 101, 104) /  580,  500,  360,  520 /
      DATA (WIDTHS(I, 27), I = 105, 108) /  580,  280,  260,  560 /
      DATA (WIDTHS(I, 27), I = 109, 112) /  300,  880,  600,  560 /
      DATA (WIDTHS(I, 27), I = 113, 116) /  580,  560,  400,  420 /
      DATA (WIDTHS(I, 27), I = 117, 120) /  360,  580,  480,  720 /
      DATA (WIDTHS(I, 27), I = 121, 124) /  540,  500,  460,  300 /
      DATA (WIDTHS(I, 27), I = 125, 128) /  660,  300,  660,  300 /
      DATA (WIDTHS(I, 27), I = 129, 132) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I = 133, 136) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I = 137, 140) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I = 141, 144) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I = 145, 148) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I = 149, 152) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I = 153, 156) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I = 157, 160) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I = 161, 164) /  300,  300,  600,  600 /
      DATA (WIDTHS(I, 27), I = 165, 168) /  600,  600,  660,  560 /
      DATA (WIDTHS(I, 27), I = 169, 172) /  360,  820,  400,  360 /
      DATA (WIDTHS(I, 27), I = 173, 176) /  660,  260,  820,  300 /
      DATA (WIDTHS(I, 27), I = 177, 180) /  400,  660,  360,  360 /
      DATA (WIDTHS(I, 27), I = 181, 184) /  280,  580,  680,  300 /
      DATA (WIDTHS(I, 27), I = 185, 188) /  380,  360,  400,  360 /
      DATA (WIDTHS(I, 27), I = 189, 192) /  900,  900,  900,  420 /
      DATA (WIDTHS(I, 27), I = 193, 196) /  740,  740,  740,  740 /
      DATA (WIDTHS(I, 27), I = 197, 200) /  740,  740,  960,  720 /
      DATA (WIDTHS(I, 27), I = 201, 204) /  660,  660,  660,  660 /
      DATA (WIDTHS(I, 27), I = 205, 208) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 27), I = 209, 212) /  760,  780,  780,  780 /
      DATA (WIDTHS(I, 27), I = 213, 216) /  780,  780,  780,  660 /
      DATA (WIDTHS(I, 27), I = 217, 220) /  780,  760,  760,  760 /
      DATA (WIDTHS(I, 27), I = 221, 224) /  760,  740,  640,  540 /
      DATA (WIDTHS(I, 27), I = 225, 228) /  520,  520,  520,  520 /
      DATA (WIDTHS(I, 27), I = 229, 232) /  520,  520,  820,  460 /
      DATA (WIDTHS(I, 27), I = 233, 236) /  500,  500,  500,  500 /
      DATA (WIDTHS(I, 27), I = 237, 240) /  280,  280,  280,  280 /
      DATA (WIDTHS(I, 27), I = 241, 244) /  560,  600,  560,  560 /
      DATA (WIDTHS(I, 27), I = 245, 248) /  560,  560,  560,  660 /
      DATA (WIDTHS(I, 27), I = 249, 252) /  560,  580,  580,  580 /
      DATA (WIDTHS(I, 27), I = 253, 256) /  580,  500,  580,  500 /
      DATA (WIDTHS(I, 28), I =   1,   4) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I =   5,   8) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I =   9,  12) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I =  13,  16) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I =  17,  20) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I =  21,  24) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I =  25,  28) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I =  29,  32) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I =  33,  36) /  340,  360,  580,  680 /
      DATA (WIDTHS(I, 28), I =  37,  40) /  680,  940,  840,  320 /
      DATA (WIDTHS(I, 28), I =  41,  44) /  340,  340,  400,  660 /
      DATA (WIDTHS(I, 28), I =  45,  48) /  340,  660,  340,  460 /
      DATA (WIDTHS(I, 28), I =  49,  52) /  680,  680,  680,  680 /
      DATA (WIDTHS(I, 28), I =  53,  56) /  680,  680,  680,  680 /
      DATA (WIDTHS(I, 28), I =  57,  60) /  680,  680,  340,  340 /
      DATA (WIDTHS(I, 28), I =  61,  64) /  660,  660,  660,  540 /
      DATA (WIDTHS(I, 28), I =  65,  68) /  860,  740,  740,  760 /
      DATA (WIDTHS(I, 28), I =  69,  72) /  820,  660,  620,  780 /
      DATA (WIDTHS(I, 28), I =  73,  76) /  820,  340,  560,  780 /
      DATA (WIDTHS(I, 28), I =  77,  80) /  600,  920,  760,  860 /
      DATA (WIDTHS(I, 28), I =  81,  84) /  680,  860,  740,  680 /
      DATA (WIDTHS(I, 28), I =  85,  88) /  680,  760,  740, 1000 /
      DATA (WIDTHS(I, 28), I =  89,  92) /  740,  740,  620,  320 /
      DATA (WIDTHS(I, 28), I =  93,  96) /  640,  320,  660,  500 /
      DATA (WIDTHS(I, 28), I =  97, 100) /  320,  580,  620,  520 /
      DATA (WIDTHS(I, 28), I = 101, 104) /  620,  560,  360,  600 /
      DATA (WIDTHS(I, 28), I = 105, 108) /  620,  300,  300,  600 /
      DATA (WIDTHS(I, 28), I = 109, 112) /  300,  920,  620,  620 /
      DATA (WIDTHS(I, 28), I = 113, 116) /  640,  620,  440,  500 /
      DATA (WIDTHS(I, 28), I = 117, 120) /  380,  620,  540,  800 /
      DATA (WIDTHS(I, 28), I = 121, 124) /  560,  540,  500,  340 /
      DATA (WIDTHS(I, 28), I = 125, 128) /  660,  340,  660,  340 /
      DATA (WIDTHS(I, 28), I = 129, 132) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I = 133, 136) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I = 137, 140) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I = 141, 144) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I = 145, 148) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I = 149, 152) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I = 153, 156) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I = 157, 160) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I = 161, 164) /  340,  360,  680,  680 /
      DATA (WIDTHS(I, 28), I = 165, 168) /  680,  680,  660,  600 /
      DATA (WIDTHS(I, 28), I = 169, 172) /  540,  840,  440,  380 /
      DATA (WIDTHS(I, 28), I = 173, 176) /  660,  340,  840,  440 /
      DATA (WIDTHS(I, 28), I = 177, 180) /  400,  660,  408,  408 /
      DATA (WIDTHS(I, 28), I = 181, 184) /  380,  620,  780,  340 /
      DATA (WIDTHS(I, 28), I = 185, 188) /  340,  408,  440,  380 /
      DATA (WIDTHS(I, 28), I = 189, 192) / 1020, 1020, 1020,  540 /
      DATA (WIDTHS(I, 28), I = 193, 196) /  740,  740,  740,  740 /
      DATA (WIDTHS(I, 28), I = 197, 200) /  740,  740, 1020,  760 /
      DATA (WIDTHS(I, 28), I = 201, 204) /  660,  660,  660,  660 /
      DATA (WIDTHS(I, 28), I = 205, 208) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 28), I = 209, 212) /  820,  760,  860,  860 /
      DATA (WIDTHS(I, 28), I = 213, 216) /  860,  860,  860,  660 /
      DATA (WIDTHS(I, 28), I = 217, 220) /  860,  760,  760,  760 /
      DATA (WIDTHS(I, 28), I = 221, 224) /  760,  740,  680,  660 /
      DATA (WIDTHS(I, 28), I = 225, 228) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 28), I = 229, 232) /  580,  580,  880,  520 /
      DATA (WIDTHS(I, 28), I = 233, 236) /  560,  560,  560,  560 /
      DATA (WIDTHS(I, 28), I = 237, 240) /  300,  300,  300,  300 /
      DATA (WIDTHS(I, 28), I = 241, 244) /  660,  620,  620,  620 /
      DATA (WIDTHS(I, 28), I = 245, 248) /  620,  620,  620,  660 /
      DATA (WIDTHS(I, 28), I = 249, 252) /  620,  620,  620,  620 /
      DATA (WIDTHS(I, 28), I = 253, 256) /  620,  540,  640,  540 /
      DATA (WIDTHS(I, 29), I =   1,   4) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I =   5,   8) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I =   9,  12) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I =  13,  16) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I =  17,  20) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I =  21,  24) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I =  25,  28) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I =  29,  32) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I =  33,  36) /  340,  380,  580,  680 /
      DATA (WIDTHS(I, 29), I =  37,  40) /  680,  900,  880,  320 /
      DATA (WIDTHS(I, 29), I =  41,  44) /  360,  360,  680,  660 /
      DATA (WIDTHS(I, 29), I =  45,  48) /  340,  660,  340,  420 /
      DATA (WIDTHS(I, 29), I =  49,  52) /  680,  680,  680,  680 /
      DATA (WIDTHS(I, 29), I =  53,  56) /  680,  680,  680,  680 /
      DATA (WIDTHS(I, 29), I =  57,  60) /  680,  680,  320,  340 /
      DATA (WIDTHS(I, 29), I =  61,  64) /  660,  660,  660,  520 /
      DATA (WIDTHS(I, 29), I =  65,  68) /  860,  760,  780,  780 /
      DATA (WIDTHS(I, 29), I =  69,  72) /  860,  700,  640,  820 /
      DATA (WIDTHS(I, 29), I =  73,  76) /  880,  400,  600,  780 /
      DATA (WIDTHS(I, 29), I =  77,  80) /  660,  960,  800,  860 /
      DATA (WIDTHS(I, 29), I =  81,  84) /  720,  880,  780,  680 /
      DATA (WIDTHS(I, 29), I =  85,  88) /  660,  800,  720, 1020 /
      DATA (WIDTHS(I, 29), I =  89,  92) /  740,  740,  620,  340 /
      DATA (WIDTHS(I, 29), I =  93,  96) /  660,  340,  660,  500 /
      DATA (WIDTHS(I, 29), I =  97, 100) /  320,  640,  640,  540 /
      DATA (WIDTHS(I, 29), I = 101, 104) /  680,  580,  420,  600 /
      DATA (WIDTHS(I, 29), I = 105, 108) /  680,  340,  340,  600 /
      DATA (WIDTHS(I, 29), I = 109, 112) /  360,  980,  680,  640 /
      DATA (WIDTHS(I, 29), I = 113, 116) /  660,  640,  460,  520 /
      DATA (WIDTHS(I, 29), I = 117, 120) /  420,  680,  580,  840 /
      DATA (WIDTHS(I, 29), I = 121, 124) /  580,  560,  500,  340 /
      DATA (WIDTHS(I, 29), I = 125, 128) /  660,  340,  660,  340 /
      DATA (WIDTHS(I, 29), I = 129, 132) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I = 133, 136) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I = 137, 140) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I = 141, 144) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I = 145, 148) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I = 149, 152) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I = 153, 156) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I = 157, 160) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I = 161, 164) /  340,  380,  660,  680 /
      DATA (WIDTHS(I, 29), I = 165, 168) /  680,  680,  660,  680 /
      DATA (WIDTHS(I, 29), I = 169, 172) /  520,  840,  440,  460 /
      DATA (WIDTHS(I, 29), I = 173, 176) /  660,  300,  840,  480 /
      DATA (WIDTHS(I, 29), I = 177, 180) /  400,  660,  408,  408 /
      DATA (WIDTHS(I, 29), I = 181, 184) /  320,  680,  660,  340 /
      DATA (WIDTHS(I, 29), I = 185, 188) /  540,  408,  440,  460 /
      DATA (WIDTHS(I, 29), I = 189, 192) / 1020, 1020, 1020,  520 /
      DATA (WIDTHS(I, 29), I = 193, 196) /  760,  760,  760,  760 /
      DATA (WIDTHS(I, 29), I = 197, 200) /  760,  760, 1000,  780 /
      DATA (WIDTHS(I, 29), I = 201, 204) /  700,  700,  700,  700 /
      DATA (WIDTHS(I, 29), I = 205, 208) /  400,  400,  400,  400 /
      DATA (WIDTHS(I, 29), I = 209, 212) /  860,  800,  860,  860 /
      DATA (WIDTHS(I, 29), I = 213, 216) /  860,  860,  860,  660 /
      DATA (WIDTHS(I, 29), I = 217, 220) /  860,  800,  800,  800 /
      DATA (WIDTHS(I, 29), I = 221, 224) /  800,  740,  720,  640 /
      DATA (WIDTHS(I, 29), I = 225, 228) /  640,  640,  640,  640 /
      DATA (WIDTHS(I, 29), I = 229, 232) /  640,  640,  900,  540 /
      DATA (WIDTHS(I, 29), I = 233, 236) /  580,  580,  580,  580 /
      DATA (WIDTHS(I, 29), I = 237, 240) /  340,  340,  340,  340 /
      DATA (WIDTHS(I, 29), I = 241, 244) /  640,  680,  640,  640 /
      DATA (WIDTHS(I, 29), I = 245, 248) /  640,  640,  640,  660 /
      DATA (WIDTHS(I, 29), I = 249, 252) /  640,  680,  680,  680 /
      DATA (WIDTHS(I, 29), I = 253, 256) /  680,  560,  660,  560 /

      DATA PSMAP /
     *    22,  9,  5, 14, 18, 26, 13,  1,
     *    24, 11,  7, 16, 20, 28, 13,  3,
     *    23, 10,  6, 15, 19, 27, 13,  2,
     *    25, 12,  8, 17, 21, 29, 13,  4 /

      DATA DESCEN /
     *    -217, -205, -205, -205,
     *    -207, -207, -207, -207,
     *    -157, -157, -142, -142,
     *    -205,
     *    -195, -195, -195, -195,
     *    -205, -205, -205, -205,
     *    -192, -192, -185, -185,
     *    -196, -193, -184, -195 /

      DATA CAPS /
     *    662, 653, 676, 669,
     *    718, 718, 718, 718,
     *    562, 562, 562, 562,
     *    667,
     *    714, 714, 714, 714,
     *    722, 722, 722, 722,
     *    740, 740, 740, 740,
     *    732, 733, 732, 732 /

      PSFONT = ABS(FONT)
      IF (PSFONT .GE. 101 .AND. PSFONT .LE. 129) THEN
        PSFONT = PSFONT - 100
      ELSE IF (PSFONT .GE. 1 .AND. PSFONT .LE. 32) THEN
        PSFONT = PSMAP(PSFONT)
      ELSE
        PSFONT = 9
      END IF

      CODE = CH + 1

      BUFF(1) = 0
      BUFF(2) = WIDTHS(CODE, PSFONT)
      BUFF(3) = CAPS(PSFONT)
      BUFF(4) = DESCEN(PSFONT)
      BUFF(5) = 0
      BUFF(6) = BUFF(3)
      BUFF(7) = BUFF(6) + 120

      END
